<?php
/* admin/includes/modules/categories/agi_google_xml.php
.---------------------------------------------------------------------------.
|    Software: GOOGLE-Shopping Feed for modified-eCommerce-Shops 2.0        |
|      Author: Andreas Guder                                                |
|     Version: 3.2                                                          |
|     Contact: info@andreas-guder.de / http://www.andreas-guder.de          |
| Copyright (c) 2016, Andreas Guder [info@andreas-guder.de]                 |
|               GNU General Public License  (Version 2)                     |
'--------------------------------------------------------------------------'
changelog:
3.1: duplicate_products: $sql_data_array darf nicht manipuliert werden
3.1: return des jeweils ersten Parameters in custom-methods
3.2: add 2nd Parameter in remove_product
*/
defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );

class agi_google_xml {
  function __construct()
  {
    $this->code = 'agi_google_xml'; //Important same name as class name
    $this->title = 'AGI Google-Export-Werte';
    $this->description = 'Save AGI-Values';        
    $this->name = 'MODULE_CATEGORIES_'.strtoupper($this->code);
    $this->enabled = defined($this->name.'_STATUS') && strtolower(constant($this->name.'_STATUS')) == 'true' ? true : false;
    $this->sort_order = defined($this->name.'_SORT_ORDER') ? constant($this->name.'_SORT_ORDER') : '';
    
    $this->translate();
  }
  
  function translate() {
    switch ($_SESSION['language_code']) {
      case 'de':
        $this->description = 'Speichert die neuen Werte des AGI-Google-XML-Exportmoduls';
        break;
      default:
        $this->description = 'Saves the values of the AGI-google-module';
        break;
    }
  }
  
  function check() {
    if (!isset($this->_check)) {
      $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = '".$this->name."_STATUS'");
      $this->_check = xtc_db_num_rows($check_query);
    }
    return $this->_check;
  }
  
  function keys() {
    define($this->name.'_STATUS_TITLE', TEXT_DEFAULT_STATUS_TITLE);
    define($this->name.'_STATUS_DESC', TEXT_DEFAULT_STATUS_DESC);
    define($this->name.'_SORT_ORDER_TITLE', TEXT_DEFAULT_SORT_ORDER_TITLE);
    define($this->name.'_SORT_ORDER_DESC', TEXT_DEFAULT_SORT_ORDER_DESC);
    
    return array(
      $this->name.'_STATUS', 
      $this->name.'_SORT_ORDER'
    );
  }

  function install() {
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('".$this->name."_STATUS', 'true','6', '1','xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('".$this->name."_SORT_ORDER', '10','6', '2', now())");
  }

  function remove() {
    xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key LIKE '".$this->name."_%'");
  }
  
  
  //--- BEGIN CUSTOM  CLASS METHODS ---//
  
  function remove_category($category_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS'))
      xtc_db_query("DELETE FROM ".TABLE_AGI_CATEGORIES_DESCRIPTION_ADD." WHERE categories_id = '".xtc_db_input($category_id)."'");
    return $category_id;
  }
  
  function insert_category_desc($sql_data_array,$categories_data,$categories_id,$language_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $dest_google_category = xtc_db_prepare_input($categories_data['google_category_'.$language_id]);
      $q = xtc_db_query("SELECT COUNT(*) as count FROM `".TABLE_AGI_CATEGORIES_DESCRIPTION_ADD."` WHERE `categories_id`='".xtc_db_input($categories_id)."' AND `language_id`=".$language_id);
      $q_count = xtc_db_fetch_array($q);
      if ($q_count['count'])
        xtc_db_perform(TABLE_AGI_CATEGORIES_DESCRIPTION_ADD, array('google_category'=>$dest_google_category), 'update', "`categories_id`='".xtc_db_input($categories_id)."' AND `language_id`=".$language_id);
      else {
        $insert = array(
          'categories_id'=> xtc_db_input($categories_id),
          'language_id'  => $language_id,
          'google_category'=> $dest_google_category
        );
        xtc_db_perform(TABLE_AGI_CATEGORIES_DESCRIPTION_ADD, $insert);
      }
    }
    return $sql_data_array;
  }
  
  function copy_category_desc($sql_data_array,$src_category_id,$dest_category_id,$ctype,$new_cat_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $cdcopy_query = xtc_db_query("SELECT * FROM ".TABLE_AGI_CATEGORIES_DESCRIPTION_ADD." WHERE categories_id = '".$dest_category_id."'");
      while ($cdcopy_values = xtc_db_fetch_array($cdcopy_query)) {
        $new_sql_data_array = $cdcopy_values;
        //set new descriptions (overrides)
        $new_sql_data_array['categories_id'] = $new_cat_id;
        //write descriptions to DB
        xtc_db_perform(TABLE_AGI_CATEGORIES_DESCRIPTION_ADD, $new_sql_data_array);
      }
    }
    return $sql_data_array;
  }
  
  function remove_product($products_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      xtc_db_query("DELETE FROM `".TABLE_AGI_PRODUCTS_ADD."` WHERE `products_id` = '".xtc_db_input($products_id)."'");
      xtc_db_query("DELETE FROM `".TABLE_AGI_PRODUCTS_DESCRIPTION_ADD."` WHERE `products_id` = '".xtc_db_input($products_id)."'");
      xtc_db_query("DELETE FROM `".TABLE_AGI_PRODUCTS_IMAGES_TO_ATTRIBUTES."` WHERE `products_id` = '".xtc_db_input($products_id)."'");
    }
    return $products_id;
  }
  function insert_product_after($products_data,$products_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $products_add = array(
        'products_id'                 => $products_id,
        'google_export'               => array_key_exists('agi_google_export', $products_data) ? 1 : 0,
        'google_condition'            => xtc_db_prepare_input($products_data['agi_google_condition']),
        'google_excluded_destination' => xtc_db_prepare_input($products_data['agi_google_excluded_destination']),
        'google_expiration_date'      => xtc_db_prepare_input($products_data['agi_google_expiration_date']),
        'google_products_brand'       => xtc_db_prepare_input($products_data['agi_google_products_brand']),
        'google_identifier_exists'    => xtc_db_prepare_input($products_data['agi_google_identifier_exists']),
        'google_multipack_amount'     => xtc_db_prepare_input($products_data['agi_google_multipack_amount']),
        'google_energy_efficiency'    => xtc_db_prepare_input($products_data['agi_google_energy_efficiency']),
        'clothing_product'            => array_key_exists('clothing_product', $products_data) ? 1 : 0,
        'google_attribute_gender'     => xtc_db_prepare_input($products_data['agi_google_attribute_gender']),
        'google_attribute_age_group'  => xtc_db_prepare_input($products_data['agi_google_attribute_age_group']),
        'google_attribute_size_type'  => xtc_db_prepare_input($products_data['agi_google_attribute_size_type']),
        'google_attribute_size_system'  => xtc_db_prepare_input($products_data['agi_google_attribute_size_system'])
      );
      
      $q = xtc_db_query("SELECT COUNT(*) as count FROM `".TABLE_AGI_PRODUCTS_ADD."` WHERE `products_id`='".xtc_db_input($products_id)."'");
      $q_count = xtc_db_fetch_array($q);
      if ($q_count['count'])
        xtc_db_perform(TABLE_AGI_PRODUCTS_ADD, $products_add, 'update', "`products_id`='".xtc_db_input($products_id)."'");
      else
        xtc_db_perform(TABLE_AGI_PRODUCTS_ADD, $products_add);
      $this->agi_prepare_attribute_images($products_id, $products_data);
    }
    return $products_data;
  }
  
  function insert_product_desc($sql_data_array,$products_data,$products_id,$language_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $products_desc_add = array(
        'products_id'               => $products_id,
        'language_id'               => $language_id,
        'google_category'           => xtc_db_prepare_input($products_data['google_category_'.$language_id]),
        'google_adwords_redirect'   => xtc_db_prepare_input($products_data['agi_google_adwords_redirect_'.$language_id]),
        'google_mobile_link'        => xtc_db_prepare_input($products_data['agi_google_mobile_link_'.$language_id]),
        'google_alternative_title'  => xtc_db_prepare_input($products_data['agi_google_alternative_title_'.$language_id]),
        'google_adwords_grouping'   => xtc_db_prepare_input($products_data['agi_google_adwords_grouping_'.$language_id]),
        'google_adwords_labels'     => xtc_db_prepare_input($products_data['agi_google_adwords_labels_'.$language_id]),
        'google_attribute_color'    => xtc_db_prepare_input($products_data['agi_google_attribute_color_'.$language_id]),
        'google_attribute_size'     => xtc_db_prepare_input($products_data['agi_google_attribute_size_'.$language_id]),
        'google_attribute_pattern'  => xtc_db_prepare_input($products_data['agi_google_attribute_pattern_'.$language_id]),
        'google_attribute_material' => xtc_db_prepare_input($products_data['agi_google_attribute_material_'.$language_id]),
        'google_custom_label0'      => xtc_db_prepare_input($products_data['agi_google_custom_label0_'.$language_id]),
        'google_custom_label1'      => xtc_db_prepare_input($products_data['agi_google_custom_label1_'.$language_id]),
        'google_custom_label2'      => xtc_db_prepare_input($products_data['agi_google_custom_label2_'.$language_id]),
        'google_custom_label3'      => xtc_db_prepare_input($products_data['agi_google_custom_label3_'.$language_id]),
        'google_custom_label4'      => xtc_db_prepare_input($products_data['agi_google_custom_label4_'.$language_id])
      );
      $q = xtc_db_query("SELECT COUNT(*) as count FROM `".TABLE_AGI_PRODUCTS_DESCRIPTION_ADD."` WHERE `products_id`='".xtc_db_input($products_id)."' AND `language_id`=".$language_id);
      $q_count = xtc_db_fetch_array($q);
      if ($q_count['count'])
        xtc_db_perform(TABLE_AGI_PRODUCTS_DESCRIPTION_ADD, $products_desc_add, 'update', "`products_id`='".xtc_db_input($products_id)."' AND `language_id`=".$language_id);
      else
        xtc_db_perform(TABLE_AGI_PRODUCTS_DESCRIPTION_ADD, $products_desc_add);
    }
    return $sql_data_array;
  }
  
  function duplicate_product_after($sql_data_array,$src_products_id,$dest_categories_id,$dup_products_id) {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $cdcopy_query = xtc_db_query("SELECT * FROM ".TABLE_AGI_PRODUCTS_ADD." WHERE products_id = '".$src_products_id."'");
      while ($cdcopy_values = xtc_db_fetch_array($cdcopy_query)) {
        $my_sql_data_array = $cdcopy_values;
        $my_sql_data_array['products_id'] = $dup_products_id;
        //write descriptions to DB
        xtc_db_perform(TABLE_AGI_PRODUCTS_ADD, $my_sql_data_array);
      }
      $cdcopy_query = xtc_db_query("SELECT * FROM ".TABLE_AGI_PRODUCTS_DESCRIPTION_ADD." WHERE products_id = '".$src_products_id."'");
      while ($cdcopy_values = xtc_db_fetch_array($cdcopy_query)) {
        $my_sql_data_array = $cdcopy_values;
        $my_sql_data_array['products_id'] = $dup_products_id;
        //write descriptions to DB
        xtc_db_perform(TABLE_AGI_PRODUCTS_DESCRIPTION_ADD, $my_sql_data_array);
      }
    }
    return $sql_data_array;
  }
  
  
  // my personal funtions
  function agi_prepare_attribute_images($products_id, $products_data)
  {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      // delete all attribute_images
      xtc_db_query("DELETE FROM `".TABLE_AGI_PRODUCTS_IMAGES_TO_ATTRIBUTES."` WHERE `products_id`=".(int)$products_id);
       
      // load actually image
      $q = "SELECT IFNULL(`products_image`,'') AS products_image FROM `".TABLE_PRODUCTS."` WHERE `products_id`='".xtc_db_input($products_id)."'";
      $q_result = xtc_db_query($q);
      $q_data = xtc_db_fetch_array($q_result);
      if (!empty($q_data['products_image']) && array_key_exists('agi_image_attribute_0', $products_data))
        $this->agi_save_attribute_images($products_data['agi_image_attribute_0'], $products_id, 0);
      
      if (defined('TABLE_PRODUCTS_IMAGES') && defined('MO_PICS'))
      {
        $q = "SELECT `image_nr` FROM `" . TABLE_PRODUCTS_IMAGES . "` WHERE `products_id` = ".(int)$products_id." ORDER BY image_nr";
        $q_result = xtc_db_query($q);
        while ($q_data = xtc_db_fetch_array($q_result))
        {
          if (array_key_exists('agi_image_attribute_'.$q_data['image_nr'], $products_data))
            $this->agi_save_attribute_images($products_data['agi_image_attribute_'.$q_data['image_nr']], $products_id, $q_data['image_nr']);
        }
      }
    }
  }
  function agi_save_attribute_images($products_image_data, $products_id, $image_id)
  {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      if (is_array($products_image_data))
      {
        foreach ($products_image_data as $value)
        {
          if (!empty($value))
          {
            $data = explode(':',$value);
            if (count($data) == 2 && !empty($data[0]))
            {
              $sql_data = array('image_nb' => $image_id, 'products_id' => $products_id, 'options_id'=> $data[0], 'options_values_id' => $data[1] == 'all' ? 0 : $data[1]);
              xtc_db_perform(TABLE_AGI_PRODUCTS_IMAGES_TO_ATTRIBUTES, $sql_data);
            }
          }
        }
      }
    }
  }
  
  function agi_load_products_attributes($products_id, $language_id)
  {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      $agi_shown_options = array();
      if (empty($products_id))
        return array();
        
      $q = "SELECT `options_id`, `options_values_id` FROM `".TABLE_PRODUCTS_ATTRIBUTES."` WHERE `products_id`=".(int)$products_id." ORDER BY `sortorder`";
      $q_result = xtc_db_query($q);
      $tmp_shown_options = array();
      $tmp_shown_options_values = array();
      $agi_product_attributes = array();
      while ($row = xtc_db_fetch_array($q_result))
      {
        $tmp_shown_options[] = $row['options_id'];
        $tmp_shown_options_values[] = $row['options_values_id'];
        $agi_product_attributes[] = array('options_id'=> $row['options_id'], 'options_values_id'=> $row['options_values_id']);
      }
      if (!empty($agi_product_attributes))
      {

        $q = "SELECT `products_options_id`, `products_options_name` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `products_options_id` IN (".implode(',',$tmp_shown_options).") AND `language_id`=".(int)$language_id." ORDER BY `products_options_sortorder`";
        $q_result = xtc_db_query($q);
        $agi_shown_options = array();
        while($row = xtc_db_fetch_array($q_result))
        {
          $agi_shown_options[$row['products_options_id']] = array('options_id'=>$row['products_options_id'], 'name'=>$row['products_options_name'], 'values'=> array());
          $agi_shown_options[$row['products_options_id']]['values'][] = array('id' => '', 'text'=>AGI_NO_IMAGE_ATTRIBUTES);
          $agi_shown_options[$row['products_options_id']]['values'][] = array('id' => $row['products_options_id'].':all', 'text'=>AGI_ALL_IMAGE_ATTRIBUTES);
        }
        if (empty($agi_shown_options))
        {
          $q = "SELECT MIN(`language_id`) AS minid FROM `".TABLE_PRODUCTS_OPTIONS."`";
          $q_result = xtc_db_fetch_array(xtc_db_query($q));
          $language_id = $q_result['minid'];
          
          $q = "SELECT `products_options_id`, `products_options_name` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `products_options_id` IN (".implode(',',$tmp_shown_options).") AND `language_id`=".(int)$language_id." ORDER BY `products_options_sortorder`";
          $q_result = xtc_db_query($q);
          $agi_shown_options = array();
          while($row = xtc_db_fetch_array($q_result))
          {
            $agi_shown_options[$key] = array('options_id'=>$row['products_options_id'], 'name'=>$row['products_options_name'], 'values'=> array());
            $agi_shown_options[$key]['values'][] = array('id' => '', 'text'=>AGI_NO_IMAGE_ATTRIBUTES);
            $agi_shown_options[$key]['values'][] = array('id' => $row['products_options_id'].':all', 'text'=>AGI_ALL_IMAGE_ATTRIBUTES);
          }
        }

        $q = "SELECT `products_options_values_id`, `products_options_values_name` FROM `".TABLE_PRODUCTS_OPTIONS_VALUES."` WHERE `products_options_values_id` IN (".implode(',',$tmp_shown_options_values).") AND `language_id`=".(int)$language_id;
        $q_result = xtc_db_query($q);
        $agi_option_values = array();
        while($row = xtc_db_fetch_array($q_result))
        {
          $agi_option_values[$row['products_options_values_id']] = $row['products_options_values_name'];
        }
        foreach ($agi_product_attributes as $row)
        {
          if (array_key_exists($row['options_id'], $agi_shown_options) && array_key_exists($row['options_values_id'], $agi_option_values))
          {
            $agi_shown_options[$row['options_id']]['values'][] = array('id'=>$row['options_id'].':'.$row['options_values_id'], 'text'=>$agi_option_values[$row['options_values_id']]);
          }
        }
      }
      return $agi_shown_options;
    }
    return array();
  }
  
  function agi_get_products_image_attribute_selection($products_attributes, $products_id = 0, $image_id = 0)
  {
    if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
      if (empty($products_attributes))
        return '';
      $image_options = array();
      $q = "SELECT * FROM `".TABLE_AGI_PRODUCTS_IMAGES_TO_ATTRIBUTES."` WHERE `products_id`=".(int)$products_id." AND `image_nb`=".(int)$image_id;
      $q_result = xtc_db_query($q);
      while ($row = xtc_db_fetch_array($q_result))
      {
        $image_options[$row['options_id']] = empty($row['options_values_id']) ? $row['options_id'].':all' : $row['options_id'].':'.$row['options_values_id'];
      }
      
      $output = '<table summary="Attribute zum Bild" border="0"><tbody>';
      foreach ($products_attributes as $option_id => $option_data)
      {
        $output .= '<tr><td class="main">';
        $output .= encode_htmlentities($option_data['name']);
        $output .= '</td><td>';
        $output .= xtc_draw_pull_down_menu('agi_image_attribute_'.$image_id.'[]', $option_data['values'], array_key_exists($option_id, $image_options) ? $image_options[$option_id] : '');
        $output .= '</td></tr>';
      }
      $output .= '</tbody></table>';
      return $output;
    }
    return '';
  }
  
}
?>