<?php
define('GOOGLE_XML_FILE_VERSION', '314');
/* export/google_quick_xml.php
.---------------------------------------------------------------------------.
|    Software: GOOGLE-Shopping Feed for modified-eCommerce-Shops 2.0        |
|      Author: Andreas Guder                                                |
|     Version: 3.14                                                         |
|     Contact: info@andreas-guder.de / http://www.andreas-guder.de          |
| Copyright (c) 2019, Andreas Guder [info@andreas-guder.de]                 |
|               GNU General Public License  (Version 2)                     |
'--------------------------------------------------------------------------'
*/
if (isset($_GET['show_version']))
  die(GOOGLE_XML_FILE_VERSION);

require '../includes/configure.php';
if (function_exists('date_default_timezone_set'))
  date_default_timezone_set('Europe/Berlin');
if (isset($_GET['error-reporting'])) {
  ini_set('display_errors','on');
  error_reporting(E_ALL);
}
else
  error_reporting(E_ALL ^E_DEPRECATED ^E_NOTICE ^E_STRICT);

$cache_days       = 1; // number of days, the xml-file will be cached before 
$export_language  = 2; // GET['lang'] language-id to export
$export_group     = 1; // GET['group'] customers-group
$limit_page       = 0; // GET['page'] number of page to export, empty or not set to export the whole database 
$country_id       = 0; // GET['country'] country-id, will be shop-country-id if empty
$zone_id          = 0; // GET['zone'] zone-id, will be shop-zone-id if empty
$currency         = 'EUR'; // GET['curr'] curency-code, will be DEFAULT_CURRENCY if empty
$add_shipping     = 0; // GET['add_shipping'], add this price/100 to shipping-costs
$export_hersteller= 0; // GET['hersteller'] // Hersteller
$campaign = ''; // $_GET['cmp'] // Kampagnen

define('LN',chr(10));

if (isset($_GET['lang']) && !empty($_GET['lang']))
  $export_language = (int) $_GET['lang'];
  
if (isset($_GET['group']) && !empty($_GET['group']))
  $export_group = (int) $_GET['group'];

if (isset($_GET['page']) && !empty($_GET['page']))
  $limit_page = (int) $_GET['page'];
  
if (isset($_GET['cache']))
  $cache_days = (int) $_GET['cache'];
  
if (isset($_GET['country'])) {
  if (preg_match('/^[A-Za-z]{2}$/', $_GET['country']))
    $country_id = strtoupper($_GET['country']);
  else
    $country_id = (int) $_GET['country'];
}
  
if (isset($_GET['curr']) && preg_match('/^[A-Za-z]{2,5}$/', $_GET['curr']))
  $currency = $_GET['curr'];

if (isset($_GET['zone']))
  $zone_id = (int) $_GET['zone'];
  
if (isset($_GET['add_shipping']))
  $add_shipping = (int) $_GET['add_shipping'];
define('ADD_SHIPPING_COSTS', $add_shipping/100);
if (!defined('SQL_CACHEDIR'))
  define('SQL_CACHEDIR', DIR_FS_CATALOG.'cache/');
  
if (isset($_GET['hersteller']) && !empty($_GET['hersteller']))
{
  $export_hersteller = preg_match('/^\d[0-9,]*$/', $_GET['hersteller']) ? (string)$_GET['hersteller'] : '';
}
$s_string_hersteller = empty($export_hersteller) ? '' : '_m'.str_replace(',','-',$export_hersteller); // Hersteller

// Kampagnen
if (isset($_GET['cmp']) && preg_match('/^\d{1,4}$/',$_GET['cmp'])) {
  $s_cmp = 'cp_'.$_GET['cmp'];
  define('EXPORT_CAMPAIGN', $_GET['cmp']);
} 
else {
  $s_cmp = '';
  define('EXPORT_CAMPAIGN', '');
}

$filename_segments = array();
$filename_segments[] = 'l'.$export_language;
$filename_segments[] = 'g'.$export_group;
$filename_segments[] = 'p'.$limit_page;
$filename_segments[] = $country_id.$zone_id;
$filename_segments[] = $currency;
$filename_segments[] = 's'.$add_shipping;
if (!empty($s_string_hersteller))
  $filename_segments[] = $s_string_hersteller;
if (!empty($s_cmp))
  $filename_segments[] = $s_cmp;
$xml_file_name = 'google_quick_xml_'.md5(implode('_',$filename_segments));

// load functions
require DIR_WS_INCLUDES.'database_tables.php';
require DIR_WS_INCLUDES.'filenames.php';

// auto include
require_once (DIR_FS_INC . 'auto_include.inc.php');

// require some functions anc classes
// Database
require_once (DIR_FS_INC.'db_functions_'.DB_MYSQL_TYPE.'.inc.php');
require_once (DIR_FS_INC.'db_functions.inc.php');

require_once (DIR_FS_INC.'xtc_get_top_level_domain.inc.php');
require_once (DIR_FS_INC.'xtc_href_link.inc.php');
require_once (DIR_FS_INC.'xtc_product_link.inc.php');

require_once (DIR_FS_INC.'xtc_category_link.inc.php');

require_once (DIR_FS_INC.'xtc_get_category_path.inc.php');
require_once (DIR_FS_INC.'xtc_get_parent_categories.inc.php');
require_once (DIR_FS_INC.'xtc_image.inc.php');
require_once (DIR_FS_INC.'xtc_get_tax_rate.inc.php');
require_once (DIR_FS_INC.'xtc_add_tax.inc.php');
require_once (DIR_FS_INC.'xtc_cleanName.inc.php');
require_once (DIR_FS_INC.'xtc_get_products_mo_images.inc.php');
require_once (DIR_FS_INC.'xtc_set_time_limit.inc.php');
require_once (DIR_FS_INC.'xtc_parse_category_path.inc.php');
require_once (DIR_FS_INC.'xtc_get_product_path.inc.php');
@xtc_set_time_limit(0);

// make a connection to the database... now
$connection = xtc_db_connect() or die('Unable to connect to database server!');
// load configuration
$configuration_query = xtc_db_query('select configuration_key as cfgKey, configuration_value as cfgValue from '.TABLE_CONFIGURATION);
while ($configuration = xtc_db_fetch_array($configuration_query)) {
	define($configuration['cfgKey'], $configuration['cfgValue']);
}

if (strtolower(MODULE_AGI_GOOGLE_XML_AUTOINCLUDE_APPLICATION_TOP_BEGINN) == 'true')
  foreach(auto_include(DIR_FS_CATALOG.'includes/extra/application_top/application_top_begin/','php') as $file) require_once ($file);

if (!defined('MODULE_AGI_GOOGLE_XML_STATUS') || strtolower(MODULE_AGI_GOOGLE_XML_STATUS) != 'true') {
  header("HTTP/1.0 403 Forbidden");
  exit;
}
if (MODULE_AGI_GOOGLE_XML_PASSWORD != '' && (empty($_GET['pass']) || MODULE_AGI_GOOGLE_XML_PASSWORD != $_GET['pass'])) {
  header("HTTP/1.0 403 Forbidden");
  exit;
}

$xml_file_name .= '.xml';
define('CACHED_EXPORT_FILE_RAW', $xml_file_name);
define('CACHED_GOOGLE_FILE', DIR_FS_CATALOG.'export/'.$xml_file_name);
defined('CATEGORIES_CONDITIONS_C') OR define('CATEGORIES_CONDITIONS_C', '');

// check cache
if ($cache_days > 0)
{
  if (file_exists(CACHED_GOOGLE_FILE))
  {
    $cached_filetime = filemtime(CACHED_GOOGLE_FILE);
    if (time()-$cached_filetime < 3000)
    {
      if (isset($_GET['out']) && $_GET['out']=='false')
        exit;
      // print out cached file
      header("Content-Type: text/xml");
      // print out header
      echo '<?xml version="1.0" encoding="UTF-8"?>',LN;
      echo '<rss xmlns:g="http://base.google.com/ns/1.0" version="2.0">'.LN;
      echo '<channel>',LN;
      if (strtolower(MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8) == 'true')
        echo '<title><![CDATA[',strip_tags(STORE_NAME),']]></title>',LN;
      else
        echo '<title><![CDATA[',mb_convert_encoding(strip_tags(STORE_NAME), 'UTF-8', 'ISO-8859-15'),']]></title>',LN;
      echo '<link>',HTTP_SERVER,'</link>',LN;
      echo '<description>Google quick product feed created at ',date('Y-m-d H:i',$cached_filetime),'</description>',LN;
      readfile(CACHED_GOOGLE_FILE);
      // print out footer
      echo '</channel>',LN;
      echo '</rss>';
      exit;
    }
  }
}
session_start();
$_SESSION['languages_id'] = $export_language;
if (strtolower(MODULE_AGI_GOOGLE_XML_USE_FUX_SEO) == 'true' && file_exists(DIR_FS_CATALOG . 'modulfux/fuxGlobal/config.php')) {
  require_once DIR_FS_CATALOG . 'modulfux/fuxGlobal/config.php';
  define('AGI_ACTIVATE_MODULEFUX_SEO_URL', true);
}
else
  define('AGI_ACTIVATE_MODULEFUX_SEO_URL', false);


// some defines
if (!defined('MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE'))
  define('MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE', 'false');
if (!defined('MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES'))
  define('MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES', 'false');
if (!defined('MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8'))
  define('MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8', 'false');
if (!defined('MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE'))
  define('MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE', 5000);

class SHOP_CONFIG
{
  private static $language_id = 2;
  private static $language_directory = 'german';
  private static $country_id  = 0;
  private static $customers_group = 1;
  private static $language_code = 'de';
  private static $language_charset = 'ISO-8859-15';
  private static $country_code  = 'DE';
  private static $zone_id   = 0;
  private static $utf8_shop = false;
  private static $default_google_category = '';
  private static $currency_to_link = false;
  
  /* Arrays */
  private static $currency = array();
  private static $ignor_vpe_values = array();
  private static $assing_vpe_values= array();
  private static $shipping_status = array();
  private static $shipping_value_table = array();
  private static $vpe_data       = array();
  private static $customers_permissions = array();
  private static $tax_rates      = array();
  
  private static $google_attribute_options = array();
  private static $google_attribute_options_ids = array();
  private static $google_attribute_options_ids_name = array();
  
  private static $attribut_export_limit = 0;
  
  private static $activate_free_amount_module = false;
  private static $value_free_amount_module = 0;
  
  public function __construct($currency, $country = 0, $zone_id = 0, $export_language = 2, $customers_group = 1)
  {
    settype($export_language, 'int');
    settype($zone_id, 'int');
    settype($customers_group, 'int');
    
    if (empty($country_id))
      $country_id = STORE_COUNTRY;
    if (empty($zone_id))
      $zone_id = STORE_ZONE;
    
    self::$utf8_shop = strtolower(MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8) == 'true' ? true : false;
    
    $q = xtc_db_query("SELECT * FROM `" . TABLE_LANGUAGES . "` WHERE `languages_id`=$export_language");
    $q_result = xtc_db_fetch_array($q);
    if ($q_result)
    {
      self::$language_id = $q_result['languages_id'];
      self::$language_code = strtolower($q_result['code']);
      self::$language_charset = strtoupper($q_result['language_charset']);
      self::$language_directory = strtolower($q_result['directory']);
    }
    $_SESSION['language_charset'] = self::$language_charset;
    include_once DIR_FS_CATALOG.'lang/'.self::$language_directory.'/modules/order_total/ot_shipping.php';
    defined('MODULE_ORDER_TOTAL_SHIPPING_TITLE') OR define('MODULE_ORDER_TOTAL_SHIPPING_TITLE','Standard');
    defined('FREE_SHIPPING_TITLE') OR define('FREE_SHIPPING_TITLE','Versandkostenfrei');
    
    // get customers_status
    $c_check = xtc_db_query("SELECT * FROM `".TABLE_CUSTOMERS_STATUS."` WHERE `customers_status_id`=$customers_group AND `language_id`=$export_language");
    if (xtc_db_num_rows($c_check) == 0)
      $c_check = xtc_db_query("SELECT * FROM `".TABLE_CUSTOMERS_STATUS."` WHERE `customers_status_id`=1 AND `language_id`=1");
    self::$customers_permissions = xtc_db_fetch_array($c_check);
    self::$customers_group = self::$customers_permissions['customers_status_id'];
    
    // load country-code
    if (preg_match('/^[A-Z]{2}$/',$country)) {
      $query = xtc_db_query("SELECT `countries_id` FROM `".TABLE_COUNTRIES."` WHERE `countries_iso_code_2`='$country' LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query);
      if (!empty($tmp))
      {
        self::$country_code = $country;
        self::$country_id   = $tmp['countries_id'];
      }
      else
      {
        $query = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`=".STORE_COUNTRY." LIMIT 0,1");
        $tmp = xtc_db_fetch_array($query);
        self::$country_code = $tmp['countries_iso_code_2'];
        self::$country_id   = STORE_COUNTRY;
      }
    }
    else {
      settype($country, 'int');
      $query = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`=$country LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query);
      if (!empty($tmp))
      {
        self::$country_code = $tmp['countries_iso_code_2'];
        self::$country_id   = $country;
      }
      else
      {
        $query = xtc_db_query("SELECT `countries_iso_code_2` FROM `".TABLE_COUNTRIES."` WHERE `countries_id`=".STORE_COUNTRY." LIMIT 0,1");
        $tmp = xtc_db_fetch_array($query);
        self::$country_code = $tmp['countries_iso_code_2'];
        self::$country_id   = STORE_COUNTRY;
      }
    }
    // load shop-zone
    if (empty($zone_id) && !empty($country_id))
    {
      $tmp = xtc_db_query("SELECT `zone_id` FROM `".TABLE_ZONES."` WHERE `zone_country_id`=$country_id LIMIT 0,1");
      $tmp = xtc_db_fetch_array($tmp);
      $zone_id = $tmp['zone_id'];
    }
    self::$zone_id = $zone_id;

    // load currency-information
    self::$currency = array('SYMBOL_LEFT'=>'', 'SYMBOL_RIGHT'=>'', 'DECIMAL_POINT'=>'', 'THOUSANDS_POINT'=>'', 'DECIMAL_PLACES'=>2, 'VALUE'=>1, 'CODE'=>'');
    $query = xtc_db_query("SELECT * FROM `".TABLE_CURRENCIES."` WHERE `code`='$currency' LIMIT 0,1");
    $tmp = xtc_db_fetch_array($query);
    if (empty($tmp))
    {
      $query = xtc_db_query("SELECT * FROM `".TABLE_CURRENCIES."` WHERE `code`='".DEFAULT_CURRENCY."' LIMIT 0,1");
      $tmp = xtc_db_fetch_array($query);
    }
    if (!empty($tmp))
    {
      self::$currency = array(
        'SYMBOL_LEFT'     => $tmp['symbol_left'],
        'SYMBOL_RIGHT'    => $tmp['symbol_right'],
        'DECIMAL_POINT'   => $tmp['decimal_point'],
        'THOUSANDS_POINT' => $tmp['thousands_point'],
        'DECIMAL_PLACES'  => $tmp['decimal_places'],
        'VALUE'           => $tmp['value'],
        'CODE'            => $tmp['code']
      );
    }
    if (strtolower(DEFAULT_CURRENCY) != strtolower(self::$currency['CODE']) && !empty(self::$currency['CODE']))
      self::$currency_to_link = true;
    $this->prepare_language_containing_constants();
    
    // load shipping-status
    $q = "SELECT `shipping_status_id` AS data_id, `google_status_name` AS data_name FROM `" . TABLE_SHIPPING_STATUS . "` WHERE `language_id`=".self::$language_id;
    self::$shipping_status = $this->load_db_table_fields($q);
    
    // load vpe-names
    $q = "SELECT `products_vpe_id`, `products_vpe_name` FROM `" . TABLE_PRODUCTS_VPE . "` WHERE `language_id`=".self::$language_id;
    $result = array();
    $q_result = xtc_db_query($q);
    while ($row = xtc_db_fetch_array($q_result))
    {
      $t = $this->explode_vpe_parts($row['products_vpe_name']);
      self::$vpe_data[$row['products_vpe_id']] = array('name'=>$row['products_vpe_name'], 'unit'=>$t['unit'], 'value'=>$t['value']);
    }
      
    // load google_attributes
    $q = "SELECT `products_options_id`, `is_google_attribute` FROM `".TABLE_PRODUCTS_OPTIONS."` WHERE `language_id` = ".self::$language_id." AND `is_google_attribute` != ''";
    $q_result = xtc_db_query($q);
    while ( $row = xtc_db_fetch_array($q_result) )
    {
      if (!array_key_exists($row['is_google_attribute'], self::$google_attribute_options_ids_name))
        self::$google_attribute_options_ids_name[$row['is_google_attribute']] = array();
      self::$google_attribute_options_ids_name[$row['is_google_attribute']][] = $row['products_options_id'];
      self::$google_attribute_options_ids[] = $row['products_options_id'];
      self::$google_attribute_options[$row['products_options_id']] = $row['is_google_attribute'];
    }
    
    $t = trim(MODULE_AGI_GOOGLE_XML_SHIPPING_LIST);
    /* 2.1 verschiedene Lnder */
    if (!empty($t))
    {
      $shippingTable = array();
      $tex = explode(';', $t);
      foreach ($tex as $row)
      {
        $tmp = explode('::', $row);
        if (count($tmp) == 2)
        {
          if (strtolower($tmp[0]) == strtolower(self::$country_code))
          {
            $shippingTable = preg_split("/[:,]/" , $tmp[1]);
            break;
          }
        }
        elseif (count($tmp) == 1)
        {
          $shippingTable = preg_split("/[:,]/" , $tmp[0]);
          break;
        }
      }
      if (empty($shippingTable))
      {
        $tmp = explode('::', $tex[0]);
        if (count($tmp) == 2)
          $shippingTable = preg_split("/[:,]/" , $tmp[1]);
        elseif (count($tmp) == 1)
          $shippingTable = preg_split("/[:,]/" , $tmp[0]);
        else
          $shippingTable = array();
      }
      self::$shipping_value_table = $shippingTable;
    }
    else
      self::$shipping_value_table = array();
    
    /* Free-Amount */
    if (defined('MODULE_SHIPPING_FREEAMOUNT_STATUS') && strtolower(MODULE_SHIPPING_FREEAMOUNT_STATUS) == 'true' ) {
      if (!defined('MODULE_SHIPPING_FREEAMOUNT_NUMBER_ZONES')) {
        if (MODULE_SHIPPING_FREEAMOUNT_ALLOWED == '' || strpos(MODULE_SHIPPING_FREEAMOUNT_ALLOWED, self::$country_code) !== FALSE) {
          self::$activate_free_amount_module = true;
          self::$value_free_amount_module = MODULE_SHIPPING_FREEAMOUNT_AMOUNT;
        }
      }
      else {
        $found_zone = 0;
        $found_value = 0;
        for ($i=1; $i<=MODULE_SHIPPING_FREEAMOUNT_NUMBER_ZONES; $i++) {
          $countries_table = constant('MODULE_SHIPPING_FREEAMOUNT_COUNTRIES_' . $i);
          $countries_table  = preg_replace("'[\r\n\s]+'",'',$countries_table);
          if ($countries_table != 'WORLD') {
            $country_zones = explode(',', $countries_table);
            if (in_array(self::$country_code, $country_zones)) {
              $found_zone = $i;
              $found_value = constant('MODULE_SHIPPING_FREEAMOUNT_AMOUNT_'.$i);
              break;
            }
          }
          else {
            $found_zone = $i;
            $found_value = constant('MODULE_SHIPPING_FREEAMOUNT_AMOUNT_'.$i);
            break;
          }
        }
        if ($found_zone > 0) {
          self::$activate_free_amount_module = true;
          self::$value_free_amount_module = $found_value;
        }
      }
    }
    if (defined('MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER') && strtolower(MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING) == 'true' && !self::$activate_free_amount_module) {
      if (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'both') {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL < MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER ? MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL : MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER;
      }
      elseif (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'national' && self::$country_id == STORE_COUNTRY) {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER;
      }
      elseif (strtolower(MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) == 'international' && self::$country_id != STORE_COUNTRY) {
        self::$activate_free_amount_module = true;
        self::$value_free_amount_module = MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER_INTERNATIONAL;
      }
    }
    
    if (defined('MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT'))
      self::$attribut_export_limit = preg_match('/^[0-9]+$/',MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT) ? MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT : 1000;
  }
  
  /**
   * constructor called function
   */
  private function prepare_language_containing_constants()
  {
    $t = $this->split_language_containing_string(MODULE_AGI_GOOGLE_XML_DEFAULT_CATEGORY, true);
    self::$default_google_category = !empty($t) ? current($t) : '';
    
    $t = $this->split_language_containing_string(MODULE_AGI_GOOGLE_XML_IGNORE_VPE_VALUES);
    foreach ($t as $key => $value) {
      self::$ignor_vpe_values[$key] = strtolower($value);
    }
    
    $t = $this->split_language_containing_string(MODULE_AGI_GOOGLE_XML_VPE_VALUES);
    $t_result = array();
    foreach ($t as $row)
    {
      $t1 = explode('=', $row);
      if (count($t1) == 2)
      {
        $t2 = array();
        foreach ($t1 as $key => $value) {
          $t2[$key] = trim($value);
        }
        $t1 = $t2;
        $t_result[strtolower($t1[0])] = $t1[1];
      }
    }
    self::$assing_vpe_values = $t_result;
  }
  
  /**
   * constructor called function
   * @param string $q
   * @return array();
   */
  private function load_db_table_fields($q = '')
  {
    if (empty($q))
      return array();
    $result = array();
    $q_result = xtc_db_query($q);
    while ($row = xtc_db_fetch_array($q_result))
      $result[$row['data_id']] = $row['data_name'];
    return $result;
  }
  
  private function explode_vpe_parts($vpe_text)
  {
    $vpe_parts = array('value' => 1, 'unit' => '');
    if (preg_match('/^[0-9]{1,}/', $vpe_text, $matches))
    {
      $vpe_parts['value'] = $matches[0];
      $vpe_parts['unit'] = trim(substr($vpe_text, strlen($vpe_parts['value'])));
    }
    else
      $vpe_parts['unit'] = trim($vpe_text);
    settype($vpe_parts['value'], 'integer');
    return $vpe_parts;
  }
  
  /**
   * @param string eq: 2stelligerSprachcode:Wert1,Wert2;2stelligerSprachcode:Wert1,Wert2
   * @return array with values for export-language
   */
  private function split_language_containing_string($string, $ignore_komma = false)
  {
    $string = html_entity_decode(trim($string), ENT_COMPAT, self::$utf8_shop ? 'UTF-8' : $_SESSION['language_charset']);
    if (empty($string))
      return array();
    
    $l_array = explode(';', $string);
    $all_results = array();
    $l_data = array();
    foreach ($l_array as $l_row)
    {
      $l_row = trim($l_row);
      if (strpos($l_row, ':') !== FALSE)
      {
        $t = explode(':', $l_row);
        $l_data[strtolower(trim($t[0]))] = trim($t[1]);
      }
      else
        $l_data[self::$language_code] = $l_row;
    }
    
    foreach ($l_data as $l_code => $l_values)
    {
      if (!$ignore_komma) {
        $t = explode(',', $l_values);
        $t2 = array();
        foreach ($t as $key => $value) {
          $t2[$key] = trim($value);
        }
        $t = $t2;
      }
      else
        $t = array($l_values);
      $all_results[$l_code] = $t;
    }
    if (empty($all_results))
      return array();
    else
      return array_key_exists(self::$language_code, $all_results) ? $all_results[self::$language_code] : current($all_results);
  }
  
  public static function get_language_id()
  {
    return self::$language_id;
  }
  public static function get_country_id()
  {
    return self::$country_id;
  }
  public static function get_zone_id()
  {
    return self::$zone_id;
  }
  public static function get_customers_group()
  {
    return self::$customers_group;
  }
  public static function get_language_code()
  {
    return self::$language_code;
  }
  public static function get_language_directory()
  {
    return self::$language_directory;
  }
  public static function get_country_code()
  {
    return self::$country_code;
  }
  public static function get_shipping_value_table()
  {
    return self::$shipping_value_table;
  }
  public static function get_google_attribute_options()
  {
    return self::$google_attribute_options;
  }
  public static function get_google_attribute_options_ids()
  {
    return self::$google_attribute_options_ids;
  }
  public static function get_google_attribute_options_ids_name()
  {
    return self::$google_attribute_options_ids_name;
  }
  public static function get_tax_rate($tax_id)
  {
    settype($tax_id, 'int');
    if (!array_key_exists($tax_id, self::$tax_rates))
      self::$tax_rates[$tax_id] = xtc_get_tax_rate($tax_id, self::$country_id, self::$zone_id);
    return self::$tax_rates[$tax_id];
  }
  public static function get_google_shipping_status($sID = 0)
  {
    settype($sID, 'int');
    $result = '';
    if (array_key_exists($sID, self::$shipping_status))
      $result = !empty(self::$shipping_status[$sID]) ? self::$shipping_status[$sID] : '';
    return empty($result) ? 'in stock' : $result;
  }
  
  public static function get_currency_value($value)
  {
    return array_key_exists($value, self::$currency) ? self::$currency[$value] : null;
  }
  public static function get_vpe_data($vID = 0, $field = 'name')
  {
    settype($vID, 'int');
    if (!in_array($field, array('name', 'unit', 'value')))
      return false;
    $result = array();
    if (array_key_exists($vID, self::$vpe_data))
      $result = !empty(self::$vpe_data[$vID]) ? self::$vpe_data[$vID] : array();
    return $result[$field];
  }
  public static function is_utf8_shop()
  {
    return self::$utf8_shop;
  }
  public static function is_currency_to_url()
  {
    return self::$currency_to_link;
  }

  public static function is_ignored_vpe_unit($value)
  {
    return in_array(strtolower($value), self::$ignor_vpe_values) ? true : false;
  }
  
  public static function replace_vpe_unit($unit = '')
  {
    return array_key_exists(strtolower($unit), self::$assing_vpe_values) ? self::$assing_vpe_values[strtolower($unit)] : $unit;
  }

  public static function get_customers_permissions($field)
  {
    if (!array_key_exists($field, self::$customers_permissions))
      return '';
    else
      return self::$customers_permissions[$field];
  }
  public static function get_google_attribute_option($value)
  {
    return array_key_exists($value, self::$google_attribute_options) ? self::$google_attribute_options[$value] : '';
  }
  
  public static function set_google_attribute_options($value)
  {
    if (!empty($value))
      self::$google_attribute_options[$value] = $value;
  }
  
  public static function calculate_price($price = 0, $format = true)
  {
    $price *= self::get_currency_value('VALUE');
    $price = round($price,2);
    if ($format)
    {
      $string = '';
      $string .= number_format(
        $price, 
        self::get_currency_value('DECIMAL_PLACES'), 
        '.', 
        ''
      );
      if (self::get_currency_value('CODE') != '')
        $string .= ' '.self::get_currency_value('CODE');
      $price = $string;
    }
    return $price;
  }
  public static function is_attribut_limit()
  {
    return self::$attribut_export_limit;
  }
  // freeamount
  public static function is_active_free_amount_module() {
    return self::$activate_free_amount_module;
  }
  public static function get_free_amount_value() {
    return self::$value_free_amount_module;
  }
}

class FEED_BUILDER
{
  private static $output_fp = null;
  private static $tmpXMLString = array();
  private static $tmpDataArray = array();
  /**
   * @param language_id
   */
  public function __construct()
  {
    // empty
  }
  
  public static function start_feed()
  {
    self::$output_fp = fopen(CACHED_EXPORT_FILE_RAW.'.tmp', 'a');
    self::$tmpXMLString = '';
  }
  public function end_feed()
  {
    fclose(self::$output_fp);
  }
  public static function write_feed_line($tring)
  {
    fwrite(self::$output_fp, $tring.LN);
  }
  public static function add_feed_item($aArray)
  {
    self::$tmpDataArray = $aArray;
    $string = self::create_xml_from_array($aArray);
    self::write_feed_line($string);
  }
  
  private static function create_xml_from_array($aArray)
  {
    self::$tmpXMLString = '';
    if (!array_key_exists('value', $aArray) || empty($aArray['value']))
      $aArray['value'] = '';
    self::$tmpXMLString .= self::get_xml_tag(
      array_key_exists('name', $aArray) && !empty($aArray['name']) ? $aArray['name'] : 'item', 
      is_array($aArray['value']) ? '' : $aArray['value'], 
      is_array($aArray['value']) ? true : false, 
      array_key_exists('attribute', $aArray) && !empty($aArray['attribute']) ? $aArray['attribute'] : array()
    );
    
    if (is_array($aArray['value']) && !empty($aArray['value']))
    {
      self::tmpXMLString_addChildren($aArray['value']);
      self::$tmpXMLString .= self::close_xml_tag(array_key_exists('name', $aArray) && !empty($aArray['name']) ? $aArray['name'] : 'item');
    }
    return self::$tmpXMLString;
  }
  private static function tmpXMLString_addChildren($aArray)
  {
    foreach ($aArray as $key => $value)
    {
      if (is_array($value))
      {
        if (!array_key_exists('value', $value) || empty($value['value']))
          $value['value'] = '';
        if (is_array($value['value']) && !empty($value['value']) && is_numeric($value['value'][0]['name'])) {
          foreach ($value['value'] as $row) {
            self::$tmpXMLString .= self::get_xml_tag(
              array_key_exists('name', $value) && !empty($value['name']) ? $value['name'] : $key, 
              is_array($row['value']) ? '' : $row['value'], 
              is_array($row['value']) ? true : false, 
              array_key_exists('attribute', $row) && !empty($value['attribute']) ? $row['attribute'] : array()
            );
          }
        }
        else {
          self::$tmpXMLString .= self::get_xml_tag(
            array_key_exists('name', $value) && !empty($value['name']) ? $value['name'] : $key, 
            is_array($value['value']) ? '' : $value['value'], 
            is_array($value['value']) ? true : false, 
            array_key_exists('attribute', $value) && !empty($value['attribute']) ? $value['attribute'] : array()
          );
          if (is_array($value['value']) && !empty($value['value']))
          {
            self::tmpXMLString_addChildren($value['value']);
            self::$tmpXMLString .= self::close_xml_tag(array_key_exists('name', $value) && !empty($value['name']) ? $value['name'] : $key);
          }
        }
      }
      else
        self::$tmpXMLString .= self::get_xml_tag($key, $value);
    }
  }
  /**
   * return attributes string of xml-tag
   * @param array of attributes ($attribute => $value,...)
   * @return string
   */
  private static function get_tag_attributes_string($attribute)
  {
    $string = '';
    foreach ($attribute as $key => $value)
    {
      $string .= ' ';
      $string .= $key.'='.self::quote_attribute($value, true);
    }
    return $string;
  }
  /**
   * return closing-tag
   * @param string
   * @return string
   */
  private static function close_xml_tag($tag)
  {
    return '</'.$tag.'>'.LN;
  }
  /**
   * return xml-tag
   * @param string $tag
   * @param string $value
   * @param bool tag has childs
   * @param array list of attributes
   * @param $maxlength
   * @return string
   */
  private static function get_xml_tag($tag, $value = '', $childs = false, $attributes = array(), $maxlength = null)
  {
    $closed = false;
    $string = '<'.$tag;
    if (!empty($attributes))
      $string .= self::get_tag_attributes_string($attributes);
    if (is_string($value) && $value == '' && !$childs)
    {
      $string .= ' />'.chr(10);
      $closed = true;
    }
    else
      $string .= '>';
    
    if (is_string($value) && (strtolower($value) != 'true' && strtolower($value) != 'false'))
    {
      if ($value != '')
        if (strpos($value, '<') !== false || strpos($value, '>') !== false || strpos($value, '&') !== false)
        $string .= '<![CDATA['.($maxlength ? $this->short_string($value, $maxlength) : $value).']]>';
      else
        $string .= $maxlength ? $this->short_string($value, $maxlength) : $value;
    }
    else
      $string .= $value;
    
    if (!$childs && !$closed)
      $string .= self::close_xml_tag($tag);
    elseif ($childs && !$closed)
      $string .= chr(10);
    
    return $string;
  }
  /**
   * UTF-8 Kodieren
   * @param mixed
   */
  private function quote_attribute($value, $quote_always=false)
  {
    if ($quote_always)
      return '"'.$value.'"';
    else
      return is_string($value) ? '"'.$value.'"' : $value;
  }
}

class PRODUCT_ITEM
{
  private $products_id = 0;
  private $products_discount = 0;
  private $product_data_raw = array();
  private $product_data_use = array();
  private $product_images = array();
  private $product_attribute_images = array();
  private $cartesian_attributes = array();
  
  private $overwrite_attributes = array();
  private $my_google_attribute_options_ids = array();
  private $my_google_attribute_options_ids_name = array();
  private $max_overwrite_attributes = 1;
  private $my_attributes_options = array(); // AGI Attribut-Link
  
  private $item_data = array();
  private $item_string = '';
  
  public function __construct($product_data)
  {
    $this->products_id = (int) $product_data['products_id'];
    $this->product_data_raw = $product_data;
    $this->product_data_use = $product_data;
    
    $this->overwrite_attributes = array();
    $this->my_google_attribute_options_ids = array();
    $this->my_google_attribute_options_ids_name = array();
    $this->clear_item_data();
  }
  
  public function clean_html_to_text($text, $short = 0)
  {
    $find     = array('</p>', '<br />', '<li />', '>');
    $replace  = array('</p>'.chr(10), '<br />'.chr(10), '</li>'.chr(10), '> ');
    $text = str_replace($find, $replace, $text);
    $cleared_text = strip_tags($text);
    $cleared_text = str_replace("&nbsp;"," ",$cleared_text);
    $cleared_text = html_entity_decode($cleared_text,ENT_QUOTES, SHOP_CONFIG::is_utf8_shop() ? 'UTF-8' : $_SESSION['language_charset']);
    $cleared_text = str_replace("'",", ",$cleared_text);
    $cleared_text = str_replace("\n"," ",$cleared_text);
    $cleared_text = str_replace("\r"," ",$cleared_text);
    $cleared_text = str_replace("\t"," ",$cleared_text);
    $cleared_text = str_replace("\v"," ",$cleared_text);
    $cleared_text = str_replace("|",",",$cleared_text);
    $cleared_text = preg_replace("/\s{2,}/"," ",$cleared_text);
    $cleared_text = preg_replace("/[[:cntrl:]]+/", '',$cleared_text);
    if ($short > 0)
    {
      $shorten = wordwrap($cleared_text, $short, "|");
      $shorten = explode("|", $shorten);
      $cleared_text = $shorten[0];
    }
    
    $cleared_text = trim($cleared_text);
    $cleared_text = htmlentities($cleared_text, ENT_COMPAT | ENT_DISALLOWED, SHOP_CONFIG::is_utf8_shop() ? 'UTF-8' : $_SESSION['language_charset']);
    return $cleared_text;
  }
  
  public function short_string($string, $maxlength)
  {
    if (strlen($string) <= $maxlength)
      return $string;
    $shorten = wordwrap($string, $maxlength, "||");
    $shorten = explode("||", $shorten);
    return $shorten[0];
  }
  
  public function add_item_data($key, $value, $attribute = array()) {
    
    if (!SHOP_CONFIG::is_utf8_shop())
      $key = $this->encode_utf8($key);

    if (is_array($value)) {
      $this->item_data['value'][$key] = array('value' => array());
      foreach ($value as $akey => $row)
      {
        if (!SHOP_CONFIG::is_utf8_shop()) {
          $akey = $this->encode_utf8($akey);
          $row = $this->encode_utf8($row);
          if (!empty($attribute)) {
            $tmp = $attribute;
            $attribute = array();
            foreach($tmp as $tKey => $tValue)
              $attribute[$this->encode_utf8($tKey)] = $this->encode_utf8($tValue);
          }
        }
        if (is_numeric($akey)) {
          $this->item_data['value'][$key]['value'][] = array(
            'name' => $akey,
            'value'=> $row,
            'attribute' => empty($attribute) ? array() : $attribute
          );
        }
        else {
          $this->item_data['value'][$key]['value'][] = array(
            'name' => $akey,
            'value'=> $row,
            'attribute' => empty($attribute) ? array() : $attribute
          );
        }
      }
    }
    else {
      if (!SHOP_CONFIG::is_utf8_shop())
        $value = $this->encode_utf8($value);
      $this->item_data['value'][$key] = $value;
    }
  }
  public function clear_item_data() {
    $this->item_data = array(
      'name' => 'item',
      'value' => array()
    );
  }
  public function encode_utf8($value) {
    return mb_convert_encoding($value, 'UTF-8', $_SESSION['language_charset']);
  }
  
  private function print_out_product()
  {
    FEED_BUILDER::add_feed_item($this->item_data);
    $this->clear_item_data();
  }
  
  /**
   * get a cartesian_product of the given attribute_array
   */
  private function get_cartesian_array($sofar,$arr,$pos,$max)
  {
    $tmp = array_keys($arr);
    for($i = 0; $i < count($arr[$tmp[$pos]]);$i++)
    {
      if($pos == $max)
        $this->cartesian_attributes[] = array_merge($sofar,array($arr[$tmp[$pos]][$i]));
      else
        $this->get_cartesian_array(array_merge($sofar,array($arr[$tmp[$pos]][$i])),$arr,$pos+1,$max);
    }
  }
  
  /**
   * combines all product-attributes (cartesian)
   * @param array
   * @return array
   */
  public function combine_attributes($arr)
  {
    $this->cartesian_attributes = array();
    $this->get_cartesian_array(array(),$arr,0,count($arr)-1);
    return $this->cartesian_attributes;
  }
  
  /**
   * return shipping-cost calculated by given shipping-table
   * @param double products_price
   * @param double products_weight
   * @return double
   */
  public function calculate_shipping_from_table($products_price, $products_weight)
  {
    $shipping = -1;
    $base = (MODULE_AGI_GOOGLE_XML_SHIPPING_BASE == 'weight') ? $products_weight : $products_price;
    if (MODULE_AGI_GOOGLE_XML_SHIPPING_BASE == 'weight' && defined('SHIPPING_BOX_WEIGHT'))
      $base += SHIPPING_BOX_WEIGHT;
    $shipping_value_table = SHOP_CONFIG::get_shipping_value_table();
    for ($i=0; $i<sizeof($shipping_value_table); $i+=2) 
    {
      if ($base <= $shipping_value_table[$i]) 
      {
        $shipping = $shipping_value_table[$i+1];
        break;
      }
    }
    if ($shipping == -1)
      $shipping = 0;
    return $shipping;
  }
  
  public function calculate_shipping()
  {
    // calculate shipping
    $s_price = $this->product_data_use['products_price'];
    if ($this->product_data_use['product_has_special']) { 
      $special_start = !empty($products_data['special_start_date']) ? strtotime($products_data['special_start_date']) : time();
      if($special_start <= time())
        $s_price = $this->product_data_use['specials_new_products_price'];
    }
    $shipping = 0;
    if (strtolower(MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES) == 'true')
    {
      $shipping = $this->calculate_shipping_from_table($s_price, $this->product_data_use['products_weight']);
      $shipping += ADD_SHIPPING_COSTS;
    }
    else
    {
      if (SHOP_CONFIG::is_active_free_amount_module() && $s_price >= SHOP_CONFIG::get_free_amount_value())
        $shipping = 0;
      else
        $shipping = $this->calculate_shipping_from_table($s_price, $this->product_data_use['products_weight']);
      if ($shipping > 0)
        $shipping += ADD_SHIPPING_COSTS;
    }
    $this->product_data_use['shipping_price'] = $shipping;
  }
  
  public function prepare_product()
  {
    $this->check_special();
    if ($this->set_personal_price() <= 0)
      return false;
    $this->set_vpe();
    $this->set_availability();
    $this->calculate_shipping();
    $this->prepare_attributes();
    if ($this->attribute_handling()) // returns true, if article has attributes, musnt print out later
      return false;
    return true;
  }
  
  private function check_special()
  {
    $this->product_data_use['product_will_have_special'] = 0;
    if (!empty($this->product_data_raw['special_start_date']) && substr($this->product_data_raw['special_start_date'],0,10) == '0000-00-00')
      $this->product_data_raw['special_start_date'] = $this->product_data_use['special_start_date'] = '';
    if (!empty($this->product_data_raw['special_expires_date']) && substr($this->product_data_raw['special_expires_date'],0,10) == '0000-00-00')
      $this->product_data_raw['special_expires_date'] = $this->product_data_use['special_expires_date'] = '';
    if($this->product_data_raw['product_has_special'] && !empty($this->product_data_raw['special_start_date'])) {
      $tmp = strtotime($this->product_data_raw['special_start_date']);
      if ($tmp > time()) {
        $this->product_data_use['product_has_special'] = 0;
        $this->product_data_use['product_will_have_special'] = 1;
      }
    }
    if($this->product_data_raw['product_has_special'] && !empty($this->product_data_raw['special_expires_date']))
    {
      $tmp = strtotime($this->product_data_raw['special_expires_date']);
      if ($tmp < time() && $tmp > 0)
        $this->product_data_use['product_has_special'] = 0;
      if ($this->product_data_raw['products_price'] > 0 && $this->product_data_raw['products_price'] < $this->product_data_raw['specials_new_products_price'])
        $this->product_data_use['product_has_special'] = 0;
    }
  }
  
  private function set_personal_price()
  {
    if (!$this->product_data_raw['product_has_special'] || $this->product_data_raw['products_price'] == 0)
    {
      if (SHOP_CONFIG::get_customers_permissions('customers_status_graduated_prices') && strtolower(MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE) == 'true')
      {
        $offer_check = xtc_db_query("SELECT `personal_offer` FROM `".TABLE_PERSONAL_OFFERS_BY.SHOP_CONFIG::get_customers_group()."` WHERE `products_id`=".$this->products_id." AND `personal_offer`>0 ORDER BY `quantity` DESC LIMIT 0,1");
        if (xtc_db_num_rows($offer_check) == 1)
        {
          $tmp = xtc_db_fetch_array($offer_check);
          if (!empty($tmp['personal_offer']))
          {
            $this->product_data_use['products_price'] = $tmp['personal_offer'];
            $this->product_data_raw['products_price'] = $tmp['personal_offer'];
          }
        }
      }
      else
      {
        $offer_check = xtc_db_query("SELECT `personal_offer` FROM `".TABLE_PERSONAL_OFFERS_BY.SHOP_CONFIG::get_customers_group()."` WHERE `products_id`=".$this->products_id." AND `personal_offer`>0 AND `quantity`=1");
        $tmp = xtc_db_fetch_array($offer_check);
        if (!empty($tmp))
        {
          $this->product_data_use['products_price'] = $tmp['personal_offer'];
          $this->product_data_raw['products_price'] = $tmp['personal_offer'];
        }
      }
    }
    if (SHOP_CONFIG::get_customers_permissions('customers_status_show_price_tax'))
    {
      $this->product_data_use['products_price'] = xtc_add_tax(
        $this->product_data_use['products_price'], 
        SHOP_CONFIG::get_tax_rate($this->product_data_raw['products_tax_class_id'])
      );
      $this->product_data_raw['products_price'] = $this->product_data_use['products_price'];
      $this->product_data_use['specials_new_products_price'] = xtc_add_tax(
        $this->product_data_use['specials_new_products_price'], 
        SHOP_CONFIG::get_tax_rate($this->product_data_raw['products_tax_class_id'])
      );
      $this->product_data_raw['specials_new_products_price'] = $this->product_data_use['specials_new_products_price'];
    }
    $products_discount = 0;
    if (!$this->product_data_raw['product_has_special'])
    {
      if (SHOP_CONFIG::get_customers_permissions('customers_status_discount') <> 0)
        $products_discount = ($this->product_data_raw['products_discount_allowed'] < SHOP_CONFIG::get_customers_permissions('customers_status_discount')) ? $this->product_data_raw['products_discount_allowed'] : SHOP_CONFIG::get_customers_permissions('customers_status_discount');
      if ($products_discount <> 0) {
        $this->product_data_use['products_price'] = $this->product_data_use['products_price']*(100-$products_discount)/100;
        $this->product_data_raw['products_price'] = $this->product_data_use['products_price'];
      }
    }
    $this->products_discount = $products_discount;
    return $this->product_data_use['products_price'];
  }
  
  private function set_vpe()
  {
    if ($this->product_data_raw['products_vpe_status'] == 1 && $this->product_data_raw['products_vpe_value'] != 0.0 && $this->product_data_raw['products_price'] > 0)
    {
      if ($vpe_name = SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe']) && !SHOP_CONFIG::is_ignored_vpe_unit(SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'name')))
      {
        $tmp_price = $this->product_data_use['product_has_special'] ? $this->product_data_use['specials_new_products_price'] : $this->product_data_use['products_price'];
        $vpe_price = SHOP_CONFIG::calculate_price($tmp_price * (1 / $this->product_data_raw['products_vpe_value']), true).' pro '.SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'name');
        $this->product_data_use['vpe'] = $vpe_price;
        
        $tmp = number_format(SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'value')*$this->product_data_raw['products_vpe_value'],3,'.','');
        $this->product_data_use['unit_pricing_measure']      = $tmp.' '.SHOP_CONFIG::replace_vpe_unit(SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'unit'));
        $this->product_data_use['unit_pricing_base_measure'] = SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'value').' '.SHOP_CONFIG::replace_vpe_unit(SHOP_CONFIG::get_vpe_data($this->product_data_raw['products_vpe'], 'unit'));
      }
      else
        $this->product_data_use['products_vpe_status'] = 0;
    }
  }
  
  private function set_availability($preset = '', $q = null)
  {
    $availability = empty($preset) ? 'in stock' : $preset;
    $quantity = $q !== null ? $q : $this->product_data_use['products_quantity'];
    if (defined('MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM'))
    {
      if (MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM == 'QUANTITY')
      {
        if ($quantity <= 0)
          $availability = 'out of stock';
        else
          $availability = 'in stock';
      }
      elseif (MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM == 'SHIPPING_TIME')
        $availability = SHOP_CONFIG::get_google_shipping_status($this->product_data_use['products_shippingtime']);
    }
    elseif (defined('MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM_QUANTITY') && strtolower(MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM_QUANTITY) == 'true')
    {
      if ($quantity <= 0)
        $availability = 'out of stock';
      else
        $availability = 'in stock';
    }
    
    $this->product_data_use['google_availability_status'] = empty($availability) ? 'in stock' : $availability;
    return $this->product_data_use['google_availability_status'];
  }
  
  private function prepare_attributes()
  {
    // get attributes set in product-details
    $this->my_google_attribute_options_ids = SHOP_CONFIG::get_google_attribute_options_ids();
    $this->my_google_attribute_options_ids_name = SHOP_CONFIG::get_google_attribute_options_ids_name();
    $check_detail_attributes = array('google_attribute_color','google_attribute_size','google_attribute_pattern','google_attribute_material');
    $this->overwrite_attributes = array();
    $this->max_overwrite_attributes = 1;
    foreach ($check_detail_attributes as $temp_a)
    {
      $tmp = preg_replace('/\s/', '', $this->product_data_use[$temp_a]);
      if (!empty($tmp))
      {
        $tmp_string = substr($temp_a,17);
        $this->overwrite_attributes[$tmp_string] = explode(';', $this->product_data_use[$temp_a]);
        $this->max_overwrite_attributes = count($this->overwrite_attributes[$tmp_string]) > $this->max_overwrite_attributes ? count($this->overwrite_attributes[$tmp_string]) : $this->max_overwrite_attributes;
        if (!array_key_exists($tmp_string, $this->my_google_attribute_options_ids_name))
          $this->my_google_attribute_options_ids_name[$tmp_string] = array();
        SHOP_CONFIG::set_google_attribute_options($tmp_string);
        if (!empty($this->my_google_attribute_options_ids_name[$tmp_string]))
          $this->my_google_attribute_options_ids = array_diff($this->my_google_attribute_options_ids, $this->my_google_attribute_options_ids_name[$tmp_string]);
      }
    }
  }
  
  private function attribute_handling()
  {
    if (!empty($this->my_google_attribute_options_ids) || !empty($this->overwrite_attributes))
    {
      $this->my_attributes_options = array(); // AGI Attribut-Link
      $allready_print_out = false;
      $attributes = array(); // entries of table 'products_attributes'
      $attributes_to_options = array();
      $found_db_attributes = 0;
      // get options from database
      if (!empty($this->my_google_attribute_options_ids))
      {
        // check for attributes
        $a_check = "SELECT COUNT(*) AS total 
        FROM 
          `".TABLE_PRODUCTS_ATTRIBUTES."` 
        WHERE 
          `products_id` = ".$this->products_id." AND 
          `options_id` IN (".implode(',', $this->my_google_attribute_options_ids).")
        ";
        $a_check = xtc_db_query($a_check);
        $a_check_result = xtc_db_fetch_array($a_check);
        $found_db_attributes = $a_check_result['total'];
        if ($found_db_attributes > 0)
        {
          // we've got attributes
          // get all attributes
          $attributes_query = xtc_db_query("SELECT pa.*, pav.products_options_values_name FROM `".TABLE_PRODUCTS_ATTRIBUTES."` AS pa, `".TABLE_PRODUCTS_OPTIONS_VALUES."` AS pav WHERE pa.products_id=".$this->products_id." AND pa.options_id IN (".implode(',', $this->my_google_attribute_options_ids).") AND pav.products_options_values_id=pa.options_values_id AND pav.language_id=".SHOP_CONFIG::get_language_id()." ORDER BY `options_id`, `sortorder`");
          while ($db_row = xtc_db_fetch_array($attributes_query))
          {
            if (!array_key_exists($db_row['options_id'], $attributes_to_options))
              $attributes_to_options[$db_row['options_id']] = array();
            $attributes_to_options[$db_row['options_id']][] = $db_row['products_attributes_id'];
            $attributes[$db_row['products_attributes_id']] = $db_row;
          }
        }
      }
      
      // get manually set options
      if (!empty($this->overwrite_attributes))
      {
        foreach ($this->overwrite_attributes as $google_name => $overrite_values)
        {
          if (!array_key_exists($google_name, $attributes_to_options))
            $attributes_to_options[$google_name] = array();
          foreach ($overrite_values as $key => $value)
          {
            $attributes_to_options[$google_name][] = $google_name.'_'.$key;
            $attributes[$google_name.'_'.$key] = array(
              'products_attributes_id'    => $google_name.'_'.$key,
              'products_id'               => $this->products_id,
              'options_id'                => $google_name,
              'options_values_id'         => 0,
              'options_values_price'      => 0,
              'price_prefix'              => '+',
              'attributes_model'          => '',
              'attributes_stock'          => $this->product_data_use['products_quantity'],
              'options_values_weight'     => 0,
              'weight_prefix'             => '+',
              'sortorder'                 => 0,
              'products_options_values_name' => trim($value),
              'attributes_vpe_value'      => 0,
              'attributes_vpe_id'         => 0,
              'attributes_ean'            => ''
            );
          }
        }
      }
      if ($found_db_attributes > 0 || $this->max_overwrite_attributes > 1)
      {
        $cnt_attributes = 0;
        $attribute_response = $this->combine_attributes($attributes_to_options); // combination of all attributes
        $overwrite_products_data = array();
        foreach ($attribute_response as $attribut_combination)
        {
          $var_amount = 0;
          $tmp_attribute_vpe_value = 0;
          $tmp_attribute_vpe_value_id = 0;
          $var_price  = round($this->product_data_raw['products_price'],2);
          $pdif = 0;
          $var_reduced_price = round($this->product_data_use['specials_new_products_price'],2);
          $var_weight = $this->product_data_use['products_weight'];
          $var_vpe_value = $this->product_data_raw['products_vpe_value'];
          $this->product_data_use['item_group_id'] = $this->products_id;
          $tmp_pid = $this->products_id;
          $tmp_google_attributes = array();
          $tmp_attributes_images = array();
          foreach ($this->my_google_attribute_options_ids_name as $key => $value)
            $tmp_google_attributes[$key] = '';

          $i_count = 0;
          foreach ($attribut_combination as $attribut_key)
          {
            $attribute_data = $attributes[$attribut_key];
            /* BOF AGI Attribut-Link */
            if ($attribute_data['options_values_id'] > 0)
              $this->my_attributes_options[$attribute_data['options_id']] = $attribute_data['options_values_id'];
            /* EOF AGI Attribut-Link */
            if (!empty($attribute_data['products_options_values_name']))
            {
              $tmp_google_attributes[SHOP_CONFIG::get_google_attribute_option($attribute_data['options_id'])] .= empty($tmp_google_attributes[SHOP_CONFIG::get_google_attribute_option($attribute_data['options_id'])]) ? $attribute_data['products_options_values_name'] : '-'.$attribute_data['products_options_values_name'];
            }
            //$tmp_pid .= '-'.$attribut_key;
            // attributkey im Klartext bergeben
            $tmp_pid .= empty($attribute_data['options_values_id']) ? '-'.$attribute_data['products_attributes_id'] : '{'.$attribute_data['options_id'].'}'.$attribute_data['options_values_id'];
            
            // get amount
            if ($i_count==0)
              $var_amount = $attribute_data['attributes_stock'];
            else
              $var_amount = ($var_amount>$attribute_data['attributes_stock']) ? $attribute_data['attributes_stock'] : $var_amount;
            
            // calculate variant-price
            if (!empty($attribute_data['options_values_price']))
            {
              $values_price = (SHOP_CONFIG::get_customers_permissions('customers_status_show_price_tax')) ? xtc_add_tax($attribute_data['options_values_price'], SHOP_CONFIG::get_tax_rate($this->product_data_raw['products_tax_class_id'])) : $attribute_data['options_values_price'];
              if ($attribute_data['price_prefix'] == '+')
              {
                $pdif += $values_price;
                //$var_price += $values_price;
                //$var_reduced_price += $values_price;
              }
              if ($attribute_data['price_prefix'] == '-')
              {
                $pdif -= $values_price;
                //$var_price -= $values_price;
                //$var_reduced_price -= $values_price;
              }
              if ($attribute_data['price_prefix'] == '=')
              {
                //$pdif += $values_price;
                $var_price = $values_price;
                $var_reduced_price = $values_price;
              }
            }
            if ($this->products_discount <> 0 && SHOP_CONFIG::get_customers_permissions('customers_status_discount_attributes'))
              $overwrite_products_data['products_price'] = $var_price+($pdif*(100-$this->products_discount)/100);
            else
              $overwrite_products_data['products_price'] = $var_price+$pdif;
            $overwrite_products_data['specials_new_products_price'] = $var_reduced_price+$pdif;
            // calculate variants-weight
            if (!empty($attribute_data['options_values_weight']))
            {
              if ($attribute_data['weight_prefix'] == '+')
                $var_weight += $attribute_data['options_values_weight'];
              if ($attribute_data['weight_prefix'] == '-')
                $var_weight -= $attribute_data['options_values_weight'];
              if ($attribute_data['weight_prefix'] == '=')
                $var_weight = $attribute_data['options_values_weight'];
              $overwrite_products_data['products_weight'] = $var_weight;
            }
              
            /** BOF VPE Anpassung */
            if ($attribute_data['attributes_vpe_value'] <> 0) {
              if ($attribute_data['weight_prefix'] == '+')
                $var_vpe_value += $attribute_data['attributes_vpe_value'];
              if ($attribute_data['weight_prefix'] == '-')
                $var_vpe_value -= $attribute_data['attributes_vpe_value'];
              if ($attribute_data['weight_prefix'] == '=')
                $var_vpe_value = $attribute_data['attributes_vpe_value'];
            }
            /*
            if ($attribute_data['attributes_vpe_value'] <> 0)
            {
              if ($tmp_attribute_vpe_value == 0)
                $tmp_attribute_vpe_value = $attribute_data['attributes_vpe_value'];
              else
                $tmp_attribute_vpe_value = $attribute_data['attributes_vpe_value'] < $tmp_attribute_vpe_value ? $attribute_data['attributes_vpe_value'] : $tmp_attribute_vpe_value;
              $tmp_attribute_vpe_value_id = $attribute_data['attributes_vpe_id'];
            }
            /** EOF VPE Anpassung */
            
            $i_count++;
          }
          //$overwrite_products_data['products_id'] = preg_match('/^[0-9\-_]+$/',$tmp_pid) ? $tmp_pid : md5($tmp_pid);
          $overwrite_products_data['products_id'] = $tmp_pid; // Attribute im Klartext bergeben
          foreach ($this->my_google_attribute_options_ids_name as $key => $value)
          {
            if (!empty($tmp_google_attributes[$key]))
              $overwrite_products_data['agi_attribute_'.$key] = $tmp_google_attributes[$key];
          }
          
          // Verfgbarkeit neu berechnen
          $quantity = $var_amount;
          if (count($attribut_combination) == 1 && empty($attribute_data['attributes_ean']))
            $quantity = $this->product_data_use['products_quantity'];
          if ($quantity < 0)
            $quantity = 0;
          $overwrite_products_data['products_quantity'] = $quantity;
          $overwrite_products_data['google_availability_status'] = $this->set_availability($this->product_data_use['google_availability_status'], $overwrite_products_data['products_quantity']);
          
          // VPE neu berechnen
          if ($this->product_data_use['products_vpe_status'] == 1 && $var_vpe_value != 0.0 && $this->product_data_raw['products_price'] > 0)
          {
            $use_vpe_id = $tmp_attribute_vpe_value_id == 0 ? $this->product_data_raw['products_vpe'] : $tmp_attribute_vpe_value_id;
            if ($vpe_name = SHOP_CONFIG::get_vpe_data($use_vpe_id) && !SHOP_CONFIG::is_ignored_vpe_unit(SHOP_CONFIG::get_vpe_data($use_vpe_id, 'name')))
            {
              $tmp_price = $this->product_data_use['product_has_special'] ? $overwrite_products_data['specials_new_products_price'] : $overwrite_products_data['products_price'];
              $vpe_price = SHOP_CONFIG::calculate_price($tmp_price * (1 / $var_vpe_value), true).' pro '.SHOP_CONFIG::get_vpe_data($use_vpe_id, 'name');
              $overwrite_products_data['vpe'] = $vpe_price;
              
              $tmp = number_format(SHOP_CONFIG::get_vpe_data($use_vpe_id, 'value')*$var_vpe_value,3,'.','');
              $overwrite_products_data['unit_pricing_measure']      = $tmp.' '.SHOP_CONFIG::replace_vpe_unit(SHOP_CONFIG::get_vpe_data($use_vpe_id, 'unit'));
              $overwrite_products_data['unit_pricing_base_measure'] = SHOP_CONFIG::get_vpe_data($use_vpe_id, 'value').' '.SHOP_CONFIG::replace_vpe_unit(SHOP_CONFIG::get_vpe_data($use_vpe_id, 'unit'));
            }
            else
              $overwrite_products_data['products_vpe_status'] = 0;
          }
          
          // Versandgewicht anpassen
          $this->product_data_use['products_price'] = $overwrite_products_data['products_price'];
          $this->calculate_shipping();
          // Produkt hier ausgeben
          $this->fill_xml_item($overwrite_products_data);
          $allready_print_out = true;
          $cnt_attributes++;
          if (SHOP_CONFIG::is_attribut_limit() && $cnt_attributes>SHOP_CONFIG::is_attribut_limit())
            return true;
        }
      }
      return $allready_print_out;
    }
    return false;
  }
  
  public function fill_xml_item($overwrite_products_data = array())
  {
    $products_data = $this->product_data_use;
    foreach($overwrite_products_data as $key => $value)
    {
      if (!array_key_exists($key, $products_data))
        $products_data[$key] = $value;
      elseif (!empty($value))
        $products_data[$key] = $value;
    }
    
    $this->add_item_data('g:id', $this->short_string($products_data['products_id'], 50));

    $this->add_item_data('g:availability', $products_data['google_availability_status']);
    $this->add_item_data('g:price', SHOP_CONFIG::calculate_price($products_data['products_price'], true));
    if ($products_data['product_has_special'] || $products_data['product_will_have_special'])
    {
      $special_start = !empty($products_data['special_start_date']) ? strtotime($products_data['special_start_date']) : time();
      $this->add_item_data('g:sale_price', SHOP_CONFIG::calculate_price($products_data['specials_new_products_price'], true));
      if (!empty($products_data['special_expires_date']))
      {
        $tmp = strtotime($products_data['special_expires_date'].' +1 day');
        if ($tmp > 0)
          $this->add_item_data('g:sale_price_effective_date', date('Y-m-d',$special_start).'T00:00'.date('O').'/'.date('Y-m-d',$tmp).'T'.date('H:iO',$tmp));
      }
      else
      {
        $tmp = time()+10*86400;
        $this->add_item_data('g:sale_price_effective_date', date('Y-m-d',$special_start).'T00:00'.date('O').'/'.date('Y-m-d',$tmp).'T'.date('H:iO',$tmp));
      }
    }
    
    $shipping_array = array(
      'g:country' => SHOP_CONFIG::get_country_code(),
      'g:service' => $this->product_data_use['shipping_price'] > 0 ? MODULE_ORDER_TOTAL_SHIPPING_TITLE : FREE_SHIPPING_TITLE,
      'g:price'   => SHOP_CONFIG::calculate_price($this->product_data_use['shipping_price'], true)
    );
    $this->add_item_data('g:shipping', $shipping_array);
    
    if (!empty($products_data['vpe']))
    {
      $this->add_item_data('g:unit_pricing_measure', $products_data['unit_pricing_measure']);
      $this->add_item_data('g:unit_pricing_base_measure', $products_data['unit_pricing_base_measure']);
    }
    
    $this->print_out_product();
  }
}

$config = new SHOP_CONFIG(empty($currency) ? DEFAULT_CURRENCY : $currency, $country_id, $zone_id, $export_language, $export_group);
$_SESSION['language_code'] = $config::get_language_code();

// Prepare general database query
$general_query = "SELECT 
    p.*, 
    IFNULL(pa.google_export, ".(strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED) == 'true' ? '1' : '0').") AS google_export,
    IFNULL(pa.google_condition, '".MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION."') AS google_condition,
    IFNULL(pa.google_excluded_destination, '') AS google_excluded_destination,
    IFNULL(pa.google_expiration_date, '') AS google_expiration_date,
    IFNULL(pa.google_products_brand, '') AS google_products_brand,
    IFNULL(pa.google_identifier_exists, ".(strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS) == 'true' ? '1' : '0').") AS google_identifier_exists,
    IFNULL(pa.google_multipack_amount, 1) AS google_multipack_amount,
    IFNULL(pa.google_energy_efficiency, '') AS google_energy_efficiency,
    IFNULL(pa.clothing_product, ".(strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT) == 'true' ? '1' : '0').") AS clothing_product,
    IFNULL(pa.google_attribute_gender, '".MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER."') AS google_attribute_gender,
    IFNULL(pa.google_attribute_age_group, '".MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP."') AS google_attribute_age_group,
    IFNULL(pa.google_attribute_size_type, '') AS google_attribute_size_type,
    IFNULL(pa.google_attribute_size_system, '') AS google_attribute_size_system,
    pd.products_short_description, 
    pd.products_name, 
    pd.products_description,
    IFNULL(pda.google_category, '') AS google_category,
    IFNULL(pda.google_adwords_redirect, '') AS google_adwords_redirect,
    IFNULL(pda.google_mobile_link, '') AS google_mobile_link,
    IFNULL(pda.google_alternative_title, '') AS google_alternative_title,
    IFNULL(pda.google_adwords_grouping, '') AS google_adwords_grouping,
    IFNULL(pda.google_adwords_labels, '') AS google_adwords_labels,
    IFNULL(pda.google_attribute_color, '') AS google_attribute_color,
    IFNULL(pda.google_attribute_size, '') AS google_attribute_size,
    IFNULL(pda.google_attribute_pattern, '') AS google_attribute_pattern,
    IFNULL(pda.google_attribute_material, '') AS google_attribute_material,
    IFNULL(pda.google_custom_label0, '') AS google_custom_label0,
    IFNULL(pda.google_custom_label1, '') AS google_custom_label1,
    IFNULL(pda.google_custom_label2, '') AS google_custom_label2,
    IFNULL(pda.google_custom_label3, '') AS google_custom_label3,
    IFNULL(pda.google_custom_label4, '') AS google_custom_label4,
    IFNULL(s.status, 0) AS product_has_special,
    IFNULL(s.specials_new_products_price, 0) AS specials_new_products_price,
    IFNULL(s.expires_date,'') AS special_expires_date,
    IFNULL(s.start_date,'') AS special_start_date
  FROM 
    `".TABLE_PRODUCTS."` AS p
    LEFT JOIN `".TABLE_AGI_PRODUCTS_ADD."` AS pa ON pa.products_id=p.products_id
    LEFT JOIN `".TABLE_PRODUCTS_DESCRIPTION."` AS pd ON pd.products_id=p.products_id AND pd.language_id=".SHOP_CONFIG::get_language_id()."
    LEFT JOIN `".TABLE_AGI_PRODUCTS_DESCRIPTION_ADD."` AS pda ON pda.products_id=p.products_id AND pda.language_id=".SHOP_CONFIG::get_language_id()."
    LEFT JOIN `".TABLE_SPECIALS."` AS s ON s.products_id=p.products_id
  WHERE 
    p.products_status=1
  ";
if (strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED) == 'true')
  $general_query .=  ' AND IFNULL(pa.google_export,1)=1 ';
else
  $general_query .=  ' AND pa.google_export=1 ';

if (strtolower(GROUP_CHECK) == 'true')
  $general_query .= " AND p.group_permission_".SHOP_CONFIG::get_customers_group()."=1";
if (!empty($export_hersteller))
  $general_query .= " AND p.manufacturers_id IN (".$export_hersteller.")"; // Hersteller

// Export FSK-Article?
if (!SHOP_CONFIG::get_customers_permissions('customers_fsk18_display'))
  $general_query .= ' AND p.products_fsk18!=1';

// GROUP BY ORDER BY
$general_query .= ' ORDER BY p.products_id ASC';

// Export-Limit ?
$limit_amount = MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE;
if ($limit_page > 0)
{
  $lstart = ($limit_page-1) * $limit_amount;
  $general_query .= " LIMIT $lstart, $limit_amount";
}
$main_product_query = xtc_db_query($general_query);
$tmp = xtc_db_num_rows($main_product_query);

if (empty($tmp))
{
  header("HTTP/1.0 204 No Content");
  exit;
}


$feed_builder = new FEED_BUILDER();
$feed_builder->start_feed();
while ($listing = xtc_db_fetch_array($main_product_query))
{
  if (empty($listing['products_image']))
    continue;
  $xml_item = new PRODUCT_ITEM($listing);
  if ($xml_item->prepare_product())
  {
    // jetzt ausgeben! nur wenn keine Attribute, da ausgabe sonst schon erledgt
    $xml_item->fill_xml_item();
  }
  unset($xml_item);
}
xtc_db_free_result($main_product_query);
$feed_builder->end_feed();

// END OUTPUT
copy(CACHED_EXPORT_FILE_RAW.'.tmp', CACHED_GOOGLE_FILE);
unlink(CACHED_EXPORT_FILE_RAW.'.tmp');
if (isset($_GET['out']) && $_GET['out']=='false')
  exit;
// print out cached file
header("Content-Type: text/xml");
// print out header
echo '<?xml version="1.0" encoding="UTF-8"?>',LN;
echo '<rss xmlns:g="http://base.google.com/ns/1.0" version="2.0">'.LN;
echo '<channel>',LN;
if (strtolower(MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8) == 'true')
  echo '<title><![CDATA[',strip_tags(STORE_NAME),']]></title>',LN;
else
  echo '<title><![CDATA[',mb_convert_encoding(strip_tags(STORE_NAME), 'UTF-8', $_SESSION['language_charset']),']]></title>',LN;
echo '<link>',HTTP_SERVER,'</link>',LN;
echo '<description>Google quick product feed created at ',date('Y-m-d H:i'),'</description>',LN;
readfile(CACHED_GOOGLE_FILE);
// print out footer
echo '</channel>',LN;
echo '</rss>';
exit;
?>