<?php
/* admin/includes/extra/modules/new_product/agi_google_xml.php
.---------------------------------------------------------------------------.
|    Software: GOOGLE-Shopping Feed for modified-eCommerce-Shops 2.0        |
|      Author: Andreas Guder                                                |
|     Version: 3.0                                                          |
|     Contact: info@andreas-guder.de / http://www.andreas-guder.de          |
| Copyright (c) 2016, Andreas Guder [info@andreas-guder.de]                 |
|               GNU General Public License  (Version 2)                     |
'--------------------------------------------------------------------------'
*/
defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );
if (defined('MODULE_AGI_GOOGLE_XML_STATUS') && defined('MODULE_CATEGORIES_AGI_GOOGLE_XML_STATUS') && strtolower(MODULE_CATEGORIES_AGI_GOOGLE_XML_STATUS) == 'true') {
  $agi_google_destination_options = array(
    array('id' => '', 'text' => TEXT_NONE),
    array('id' => 'Shopping', 'text' => 'Shopping')
  );
  $agi_google_condition_options = array(
    array('id' => 'new', 'text' => AGI_GOOGLE_CONDITION_NEW),
    array('id' => 'used', 'text' => AGI_GOOGLE_CONDITION_USED),
    array('id' => 'refurbished', 'text' => AGI_GOOGLE_CONDITION_REFURBISHED)
  );
  $agi_google_energy_options = array(
    array('id' => '', 'text' => ''),
    array('id' => 'A+++', 'text' => 'A+++'),
    array('id' => 'A++', 'text' => 'A++'),
    array('id' => 'A+', 'text' => 'A+'),
    array('id' => 'A', 'text' => 'A'),
    array('id' => 'B', 'text' => 'B'),
    array('id' => 'C', 'text' => 'C'),
    array('id' => 'D', 'text' => 'D'),
    array('id' => 'E', 'text' => 'E'),
    array('id' => 'F', 'text' => 'F'),
    array('id' => 'G', 'text' => 'G')
  );
  $clothing_gender_options = array(
    array('id' => 'unisex', 'text' => AGI_GOOGLE_ATTRIBUTE_GENDER_UNISEX),
    array('id' => 'female', 'text' => AGI_GOOGLE_ATTRIBUTE_GENDER_FEMALE),
    array('id' => 'male', 'text' => AGI_GOOGLE_ATTRIBUTE_GENDER_MALE)
  );
  $clothing_age_group_options = array(
    array('id' => 'adult', 'text' => AGI_GOOGLE_ATTRIBUTE_AGE_GROUP_ADULT),
    array('id' => 'kids', 'text' => AGI_GOOGLE_ATTRIBUTE_AGE_GROUP_KIDS),
    array('id' => 'newborn', 'text' => AGI_GOOGLE_ATTRIBUTE_AGE_GROUP_NEWBORN),
    array('id' => 'infant', 'text' => AGI_GOOGLE_ATTRIBUTE_AGE_GROUP_INFANT),
    array('id' => 'toddler', 'text' => AGI_GOOGLE_ATTRIBUTE_AGE_GROUP_TODDLER)
  );
  $clothing_size_type = array(
    array('id' => '', 'text' => ''),
    array('id' => 'regular', 'text' => AGI_GOOGLE_ATTRIBUTE_SIZE_TYPE_REGULAR),
    array('id' => 'petite', 'text' => AGI_GOOGLE_ATTRIBUTE_SIZE_TYPE_PETITE),
    array('id' => 'plus', 'text' => AGI_GOOGLE_ATTRIBUTE_SIZE_TYPE_PLUS),
    array('id' => 'maternity', 'text' => AGI_GOOGLE_ATTRIBUTE_SIZE_TYPE_MATERNITY)
  );
  $clothing_size_system = array(
    array('id' => '', 'text' => AGI_GOOGLE_ATTRIBUTE_SIZE_SYSTEM_DEFAULT),
    array('id' => 'US', 'text' => 'US'),
    array('id' => 'UK', 'text' => 'UK'),
    array('id' => 'EU', 'text' => 'EU'),
    array('id' => 'DE', 'text' => 'DE'),
    array('id' => 'FR', 'text' => 'FR'),
    array('id' => 'JP', 'text' => 'JP'),
    array('id' => 'CN', 'text' => 'CN'),
    array('id' => 'IT', 'text' => 'IT'),
    array('id' => 'BR', 'text' => 'BR'),
    array('id' => 'MEX', 'text' => 'MEX'),
    array('id' => 'AU', 'text' => 'AU')
  );
  
  $agi_google_data = array();
  if (!empty($pInfo->products_id))
  {
    $q = xtc_db_query("SELECT * FROM `".TABLE_AGI_PRODUCTS_ADD."` WHERE `products_id`=".$pInfo->products_id);
    $agi_google_data = xtc_db_fetch_array($q);
    $agi_google_data['language_data'] = array();
    $q = xtc_db_query("SELECT * FROM `".TABLE_AGI_PRODUCTS_DESCRIPTION_ADD."` WHERE `products_id`=".$pInfo->products_id);
    while ($qdata = xtc_db_fetch_array($q))
      $agi_google_data['language_data'][$qdata['language_id']] = $qdata;
  }
  function agi_get_value($field, $data)
  {
    $preselect = array(
      'google_export'               => strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED) == 'true' ? 1 : 0,
      'clothing_product'            => strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT) == 'true' ? 1 : 0,
      'google_identifier_exists'    => strtolower(MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS) == 'true' ? 1 : 0,
      'google_condition'            => MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION,
      'google_attribute_gender'     => MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER,
      'google_attribute_age_group'  => MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP,
      'google_attribute_size_type'  => MODULE_AGI_GOOGLE_XML_PRESELECT_SIZETYPE
    );
    if (!array_key_exists($field, $data))
      return array_key_exists($field, $preselect) ? $preselect[$field] : null;
    else
      return $data[$field];
  }
  $tmp = defined('AGI_GOOGLE_CUSTOM_LABEL_TITLE') ? unserialize(AGI_GOOGLE_CUSTOM_LABEL_TITLE) : array();
  $google_cl_title = array();
  for ($i=0; $i<=4; $i++) 
  {
    $google_cl_title[$i] = empty($tmp[$i]) ? 'Custom Label '.($i+1) : $tmp[$i];
  }
  
  $agi_google_taxonomie_list = array();
  $agi_google_taxonomie_selected = array();
  for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
    $tmp = agi_get_value('language_data', $agi_google_data);
    if (empty($tmp))
      $tmp = array();
    $selected = agi_get_value('google_category', array_key_exists($languages[$i]['id'], $tmp) ? $tmp[$languages[$i]['id']] : array());
    $agi_google_taxonomie_list[$languages[$i]['code']] = array(array('id'=>0, 'text'=>''));
    $agi_google_taxonomie_selected[$languages[$i]['code']] = !empty($selected) ? $selected : '';
    if (file_exists(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt')) {
      $tmp_data = file(DIR_FS_DOCUMENT_ROOT.'export/google_taxonomie.'.$languages[$i]['code'].'.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
      foreach ($tmp_data as $key => $value) {
        if (strlen($value) > 100) {
          $last = substr($value, -110);
          $parsed_value = '[..] '.substr($last, strpos($last, '>') !== false ? strpos($last, '>')+2 : 0);
        }
        else
          $parsed_value = $value;
        $agi_google_taxonomie_list[$languages[$i]['code']][] = array('id'=>$value, 'text'=>encode_htmlentities($parsed_value));
      }
    }
  }
?>
  <div style="padding:5px;" class="clear div_box mrg5">
    <div class="main div_header"><?php echo AGI_GOOGLE_EXPORT_HEADING. draw_tooltip(AGI_GOOGLE_EXPORT_TOOLTIPP) ?></div>
    <div class="clear div_box mrg5">
      <div style="float:left; width:57%; vertical-align:top">
        <table class="tableInput border0">
          <tr>
            <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_EXPORT_ALLOWED_TOOLTIPP).' '.AGI_GOOGLE_EXPORT_ALLOWED ?></span></td>
            <td><span class="main"><?php echo xtc_draw_selection_field('agi_google_export', 'checkbox', '1', agi_get_value('google_export', $agi_google_data)==1 ? true : false); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_IDENTIFIER_EXISTS_TOOLTIPP).' '.AGI_GOOGLE_IDENTIFIER_EXISTS ?></span></td>
            <td><span class="main"><?php echo xtc_draw_selection_field('agi_google_identifier_exists', 'checkbox', '1', agi_get_value('google_identifier_exists', $agi_google_data)==1 ? true : false); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_CONDITION ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_condition', $agi_google_condition_options, agi_get_value('google_condition', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_PRODUCTS_BRAND ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_google_products_brand', agi_get_value('google_products_brand', $agi_google_data), 'style="width:200px"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_ATTRIBUTE_GENDER; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_attribute_gender', $clothing_gender_options, agi_get_value('google_attribute_gender', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_ATTRIBUTE_SIZE_TYPE; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_attribute_size_type', $clothing_size_type, agi_get_value('google_attribute_size_type', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_EXCLUDED_DESTINATION ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_excluded_destination', $agi_google_destination_options, agi_get_value('google_excluded_destination', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
        </table>
      </div>
      
      <div style="float:left;width:43%; vertical-align:top">
        <table class="tableInput border0">
          <tr>
            <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_ATTRIBUTE_CLOTHING_TOOLTIPP).' '.AGI_GOOGLE_ATTRIBUTE_CLOTHING_TITLE ?></span></td>
            <td><span class="main"><?php echo xtc_draw_selection_field('clothing_product', 'checkbox', '1', agi_get_value('clothing_product', $agi_google_data)==1 ? true : false); ?></span></td>
          </tr>
          <tr>
            <td colspan="2">&nbsp;</td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_MULTIPACK_AMOUNT ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_google_multipack_amount', agi_get_value('google_multipack_amount', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_ENERGY_EFFICIENCY ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_energy_efficiency', $agi_google_energy_options, agi_get_value('google_energy_efficiency', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_ATTRIBUTE_AGE_GROUP; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_attribute_age_group', $clothing_age_group_options, agi_get_value('google_attribute_age_group', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_ATTRIBUTE_SIZE_SYSTEM; ?></span></td>
            <td><span class="main"><?php echo xtc_draw_pull_down_menu('agi_google_attribute_size_system', $clothing_size_system, agi_get_value('google_attribute_size_system', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
          <tr>
            <td><span class="main"><?php echo AGI_GOOGLE_EXPIRATION_DATE ?></span></td>
            <td><span class="main"><?php echo xtc_draw_input_field('agi_google_expiration_date', agi_get_value('google_expiration_date', $agi_google_data), 'style="max-width:250px; width:200px;"'); ?></span></td>
          </tr>
        </table>
      </div>
      <div style="clear:both;"></div>
      
      <div style="padding:5px;clear:both;">
        <div class="tablangmenu">
          <ul>
          <?php for ($i = 0, $n = sizeof($languages); $i < $n; $i++) { ?>
            <li id="agi_lang_tabselect_<?php echo $i; ?>" onclick="agiShowTab('agi_lang',<?php echo $i; ?>,<?php echo $n; ?>)" style="cursor:pointer; <?php echo $i==0 ? ' color:#000;background-color:#d0d0d0;' : ''?>"><?php echo xtc_image(DIR_WS_LANGUAGES . $languages[$i]['directory'] .'/admin/images/'. $languages[$i]['image'], $languages[$i]['name']) . ' ' . $languages[$i]['name']; ?></li>
          <?php } ?>
          </ul>
        </div>
        <?php for ($i = 0, $n = sizeof($languages); $i < $n; $i++) { ?>
          <?php 
            $lng_image = xtc_image(DIR_WS_LANGUAGES . $languages[$i]['directory'] .'/admin/images/'. $languages[$i]['image'], $languages[$i]['name']); 
            $tmp = agi_get_value('language_data', $agi_google_data);
            if (empty($tmp))
              $tmp = array();
            $plangdata = array_key_exists($languages[$i]['id'], $tmp) ? $tmp[$languages[$i]['id']] : array();
          ?>
          <div id="agi_lang_tab_<?php echo $i; ?>" style="display:<?php echo $i>0 ? 'none;':'block;';?> border:1px solid #aaa;">
            <p><?php echo $lng_image.' '.$languages[$i]['name']; ?></p>
            <table class="tableInput border0">
              <tr>
                <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_ATTRIBUTE_COLOR_TOOLTIPP).' '.AGI_GOOGLE_ATTRIBUTE_COLOR; ?></span></td>
                <td><span class="main"><?php echo xtc_draw_input_field('agi_google_attribute_color_'.$languages[$i]['id'], agi_get_value('google_attribute_color', $plangdata), 'style="width:100%"'); ?></span></td>
                <td style="width: 30px"></td>
                <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_ATTRIBUTE_SIZE_TOOLTIPP).' '.AGI_GOOGLE_ATTRIBUTE_SIZE; ?></span></td>
                <td><span class="main"><?php echo xtc_draw_input_field('agi_google_attribute_size_'.$languages[$i]['id'], agi_get_value('google_attribute_size', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
              <tr>
                <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_ATTRIBUTE_PATTERN_TOOLTIPP).' '.AGI_GOOGLE_ATTRIBUTE_PATTERN; ?></span></td>
                <td><span class="main"><?php echo xtc_draw_input_field('agi_google_attribute_pattern_'.$languages[$i]['id'], agi_get_value('google_attribute_pattern', $plangdata), 'style="width:100%"'); ?></span></td>
                <td style="width: 30px"></td>
                <td><span class="main"><?php echo draw_tooltip(AGI_GOOGLE_ATTRIBUTE_MATERIAL_TOOLTIPP).' '.AGI_GOOGLE_ATTRIBUTE_MATERIAL; ?></span></td>
                <td><span class="main"><?php echo xtc_draw_input_field('agi_google_attribute_material_'.$languages[$i]['id'], agi_get_value('google_attribute_material', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
            </table>
            <hr />
            <table class="tableInput border0">
              <tr>
                <td><span class="main"><?php echo AGI_GOOGLE_ADWORDS_GROUPING ?></span></td>
                <td><?php echo xtc_draw_input_field('agi_google_adwords_grouping_'.$languages[$i]['id'], agi_get_value('google_adwords_grouping', $plangdata), 'style="width:100%"'); ?></td>
                <td style="width: 30px"></td>
                <td><span class="main"><?php echo AGI_GOOGLE_ADWORDS_LABELS ?></span></td>
                <td><span class="main"><?php echo xtc_draw_input_field('agi_google_adwords_labels_'.$languages[$i]['id'], agi_get_value('google_adwords_labels', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
              <tr>
                <td><span class="main"><?php echo AGI_GOOGLE_ADWORDS_REDIRECT ?></span></td>
                <td colspan="4"><span class="main"><?php echo xtc_draw_input_field('agi_google_adwords_redirect_'.$languages[$i]['id'], agi_get_value('google_adwords_redirect', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
              <tr>
                <td><span class="main"><?php echo AGI_GOOGLE_MOBILE_LINK ?></span></td>
                <td colspan="4"><span class="main"><?php echo xtc_draw_input_field('agi_google_mobile_link_'.$languages[$i]['id'], agi_get_value('google_mobile_link', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
              <tr>
                <td><span class="main"><?php echo AGI_GOOGLE_ALTERNATIVE_TITLE ?></span></td>
                <td colspan="4"><span class="main"><?php echo xtc_draw_input_field('agi_google_alternative_title_'.$languages[$i]['id'], agi_get_value('google_alternative_title', $plangdata), 'style="width:100%"'); ?></span></td>
              </tr>
              <tr>
                <td><span class="main"><?php echo AGI_GOOGLE_CUSTOM_LABEL ?></span></td>
                <td colspan="4">
                  <table style="width: 100%;" cellspacing="0" cellpadding="1" >
                    <tr> 
                    <?php for ($ix=0; $ix<=4; $ix++) { ?>
                      <th><span class="main"><?php echo $google_cl_title[$ix]; ?></span></th>
                    <?php } ?>
                    </tr>
                    <tr>
                    <?php for ($ix=0; $ix<=4; $ix++) { ?>
                      <td><span class="main"><?php echo xtc_draw_input_field('agi_google_custom_label'.$ix.'_'.$languages[$i]['id'], agi_get_value('google_custom_label'.$ix, $plangdata), 'style="width:90%"'); ?></span></td>
                    <?php } ?>
                    </tr>
                  </table>
                </td>
              </tr>
              <tr>
                <td rowspan="2"><span class="main"><?php echo AGI_GOOGLE_CATEGORY; ?></span>
                <td colspan="4">
                <span class="main"><small><?php echo AGI_GOOGLE_CATEGORY_DESC; ?></small></span><br />
                <?php echo xtc_draw_input_field('google_category_'.$languages[$i]['id'], agi_get_value('google_category', $plangdata), 'size="50" style="width: 100%" id="google_category_'.$languages[$i]['id'].'"'); ?></td>
              </tr>
              <tr>
                <td colspan="4">
                  <?php echo xtc_draw_pull_down_menu('agi_taxonomie_select_'.$languages[$i]['id'], $agi_google_taxonomie_list[$languages[$i]['code']], $agi_google_taxonomie_selected[$languages[$i]['code']], 'style="width:95%;" id="agi_taxonomie_select_'.$languages[$i]['id'].'"'); ?><br />
                 <?php echo '<a href="#" class="button" title="'.AGI_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'" onclick="agiFillinGoogleCategory('.$languages[$i]['id'].');return false;">'.AGI_GOOGLE_TAXONOMIE_FILLIN_BUTTON.'</a>'; ?>
                </td>
              </tr>
            </table>
          </div>
        <?php } ?>
        <span class="main"><a href="https://support.google.com/merchants/answer/188494" target="_blank">https://support.google.com/merchants/answer/188494</a></span>
      </div>
    
    </div>
  </div>
<?php } ?>