<?php
/* admin/includes/modules/export/agi_google_xml.php
.---------------------------------------------------------------------------.
|    Software: GOOGLE-Shopping Feed for modified-eCommerce-Shops 2.0        |
|      Author: Andreas Guder                                                |
|     Version: 3.0                                                          |
|     Contact: info@andreas-guder.de / http://www.andreas-guder.de          |
| Copyright (c) 2016, Andreas Guder [info@andreas-guder.de]                 |
|               GNU General Public License  (Version 2)                     |
'--------------------------------------------------------------------------'
*/
defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );
class agi_google_xml {
  var $code, $title, $description, $enabled, $sort_order;
  
  function __construct() {
		$this->code = 'agi_google_xml';
		$this->title = MODULE_AGI_GOOGLE_XML_TITLE;
		$this->description = MODULE_AGI_GOOGLE_XML_TEXT_LONG_DESCRIPTION;
		$this->sort_order = defined('MODULE_AGI_GOOGLE_XML_SORT_ORDER') ? MODULE_AGI_GOOGLE_XML_SORT_ORDER : 0;
		$this->enabled = ((strtolower(MODULE_AGI_GOOGLE_XML_STATUS) == 'true') ? true : false);
	}
  
  function process($file) {
    $q = "ALTER TABLE `agi_products_add` CHANGE `google_export` `google_export` tinyint(1) NOT NULL DEFAULT ".($_POST['configuration']['MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED'] == 'true' ? 1 : 0);
    xtc_db_query($q);
    $q = "ALTER TABLE `agi_products_add` CHANGE `google_condition` `google_condition` varchar(64) NOT NULL DEFAULT '".$_POST['configuration']['MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION']."'";
    xtc_db_query($q);
    $q = "ALTER TABLE `agi_products_add` CHANGE `google_identifier_exists` `google_identifier_exists` tinyint(1) NOT NULL DEFAULT ".($_POST['configuration']['MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS'] == 'true' ? 1 : 0);
    xtc_db_query($q);
    $q = "ALTER TABLE `agi_products_add` CHANGE `clothing_product` `clothing_product` tinyint(1) NOT NULL DEFAULT ".($_POST['configuration']['MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT'] == 'true' ? 1 : 0);
    xtc_db_query($q);
	}

	function display() {
		return array('text' => '<br /><div align="center">' . xtc_button(BUTTON_SAVE) .
			xtc_button_link(BUTTON_CANCEL, xtc_href_link(FILENAME_MODULE_EXPORT, 'set=' . $_GET['set'] . '&module=agi_google_xml')) . "</div>");
	}
  
  function check() {
		if (!isset($this->_check)) {
			$check_query = xtc_db_query("SELECT configuration_value 
                                    FROM " . TABLE_CONFIGURATION . "
                                    WHERE configuration_key = 'MODULE_AGI_GOOGLE_XML_STATUS'");
			$this->_check = xtc_db_num_rows($check_query);
		}
		return $this->_check;
	}
  
  function install() {
      $keys = $this->keys();
      
      if (defined('MODULE_AGI_GOOGLE_XML_STATUS')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=1, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_STATUS'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_STATUS'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_STATUS', 'true', '46163', '1', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      
      if (defined('MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=1, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL', 'false', '46163', '1', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=2 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE', '5000', '46163', '2', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_VPE_TITLE')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=5, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_VPE_TITLE'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_VPE_TITLE'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_VPE_TITLE', 'false', '46163', '5', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_VPE_DESCRIPTION')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=6, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_VPE_DESCRIPTION'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_VPE_DESCRIPTION'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_VPE_DESCRIPTION', 'false', '46163', '6', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_CHECK_GRADUATED_PRICE')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_key` ='MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE', `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_CHECK_GRADUATED_PRICE'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE'");
      }
      elseif (defined('MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=10, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE', 'false', '46163', '10', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_LONG_DESCRIPTION')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=15, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_LONG_DESCRIPTION'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_LONG_DESCRIPTION'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_LONG_DESCRIPTION', 'true', '46163', '15', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=20, `set_function`='agi_cfg_select_option(array(\'IN_STOCK\'=>\'immer Verfgbar\', \'QUANTITY\'=>\'Anzahl, Bestand\', \'SHIPPING_TIME\'=>\'Lieferstatus\'), \'MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM\', ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM'");
      else {
        $preset = 'immer Verfgbar';
        if (strpos(strtolower($_SESSION['language_charset']),'utf') !== false)
          $preset = utf8_encode($preset);
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM', 'QUANTITY', '46163', '20', 'agi_cfg_select_option(array(\'IN_STOCK\'=>\'".$preset."\', \'QUANTITY\'=>\'Anzahl, Bestand\', \'SHIPPING_TIME\'=>\'Lieferstatus\'), \'MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM\', ', now())");
      }
      if (defined('MODULE_AGI_GOOGLE_XML_SHIPPING_LIST'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=25 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_SHIPPING_LIST'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_SHIPPING_LIST', '0:4.95,50:0', '46163', '25', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_SHIPPING_BASE'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=26 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_SHIPPING_BASE'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_SHIPPING_BASE', 'price', '46163', '26', 'xtc_cfg_select_option(array(\'price\', \'weight\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_IGNORE_FREESHIPPING_MODULES')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_key` ='MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES', `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_IGNORE_FREESHIPPING_MODULES'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES'");
      }
      elseif (defined('MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=27, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES', 'false', '46163', '27', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_USE_PRODUCT_IMAGE'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=30, `set_function`='xtc_cfg_select_option(array(\'popup_images\',\'info_images\',\'original_images\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_USE_PRODUCT_IMAGE'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_USE_PRODUCT_IMAGE', 'popup_images', '46163', '30', 'xtc_cfg_select_option(array(\'popup_images\',\'info_images\',\'original_images\'), ', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_DEFAULT_CATEGORY'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=35 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_DEFAULT_CATEGORY'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_DEFAULT_CATEGORY', '', '46163', '35', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_DEFAULT_CL_SIZESYSTEM'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=36 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_DEFAULT_CL_SIZESYSTEM'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_DEFAULT_CL_SIZESYSTEM', 'EU', '46163', '36', 'xtc_cfg_select_option(array(\'US\',\'UK\',\'EU\',\'DE\',\'FR\',\'JP\',\'CN\',\'IT\',\'BR\',\'MEX\',\'AU\'), ', now())");
      
      if (!defined('MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT', '500', '46163', '75', '', now())");
      if (defined('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_MALE'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=80 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_MALE'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_MALE', 'herr,mann,herren', '46163', '80', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_FEMALE'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=81 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_FEMALE'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_FEMALE', 'frau,dame,damen,frauen', '46163', '81', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_UNISEX'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=82 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_UNISEX'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_GENDER_WORDS_UNISEX', 'unisex', '46163', '82', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_KIDS'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=83 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_KIDS'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_KIDS', 'kind,kinder,kids', '46163', '83', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_ADULT'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=84 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_ADULT'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_ADULT', 'erwachsen,normal', '46163', '84', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_NEWBORN'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=85 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_NEWBORN'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_NEWBORN', 'neugeboren,neugeborene,bis 3 monate', '46163', '85', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_INFANT'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=86 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_INFANT'");
      else {
        $preset = 'sugling,suglinge,baby,3 bis 12 monate';
        if (strpos(strtolower($_SESSION['language_charset']),'utf') !== false)
          $preset = utf8_encode($preset);
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_INFANT', '".$preset."', '46163', '86', '', now())");
      }
      if (defined('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_TODDLER'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=87 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_TODDLER'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_TODDLER', 'kleinkind,kleinkinder,1 bis 5 jahre', '46163', '87', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_VPE_VALUES'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=100 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_VPE_VALUES'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_VPE_VALUES', '', '46163', '100', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_IGNORE_VPE_VALUES'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=101 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_IGNORE_VPE_VALUES'");
      else {
        $preset = 'de:Stck;en:piece';
        if (strpos(strtolower($_SESSION['language_charset']),'utf') !== false)
          $preset = utf8_encode($preset);
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_IGNORE_VPE_VALUES', '".$preset."', '46163', '101', '', now())");
      }
      if (defined('MODULE_AGI_GOOGLE_XML_CAMPAIGN'))
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=105 WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_CAMPAIGN'");
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_CAMPAIGN', 'pk_campaign=google_shopping', '46163', '105', '', now())");

      if (defined('MODULE_AGI_GOOGLE_XML_IS_GZIP'))
        xtc_db_query("DELETE FROM `".TABLE_CONFIGURATION."` WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_IS_GZIP'");

      if (defined('MODULE_AGI_GOOGLE_XML_EXPORT_SSL_LINKS')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=205, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_EXPORT_SSL_LINKS'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_EXPORT_SSL_LINKS'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_EXPORT_SSL_LINKS', 'false', '46163', '204', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (defined('MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=205, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8', 'false', '46163', '205', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (defined('MODULE_AGI_GOOGLE_XML_USE_FUX_SEO')) {
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_group_id` =46163, `sort_order`=206, `set_function`='xtc_cfg_select_option(array(\'true\', \'false\'), ' WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_USE_FUX_SEO'");
        xtc_db_query("UPDATE `".TABLE_CONFIGURATION."` SET `configuration_value`=LOWER(`configuration_value`) WHERE `configuration_key` = 'MODULE_AGI_GOOGLE_XML_USE_FUX_SEO'");
      }
      else
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_USE_FUX_SEO', 'false', '46163', '206', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_AUTOINCLUDE_APPLICATION_TOP_BEGINN'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_AUTOINCLUDE_APPLICATION_TOP_BEGINN', 'false', '46163', '207', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED', 'true', '46163', '510', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT', 'false', '46163', '515', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS', 'true', '46163', '525', 'xtc_cfg_select_option(array(\'true\', \'false\'), ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION', 'new', '46163', '530', 'agi_cfg_select_option(array(\'new\'=>\'neu\', \'used\'=>\'gebraucht\', \'refurbished\'=>\'erneuert\'), \'MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION\', ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER', 'unisex', '46163', '535', 'agi_cfg_select_option(array(\'unisex\'=>\'unisex\', \'female\'=>\'Damen\', \'male\'=>\'Herren\'), \'MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER\', ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP', 'adult', '46163', '540', 'agi_cfg_select_option(array(\'adult\'=>\'Erwachsene\', \'kids\'=>\'Kinder\', \'newborn\'=>\'Neugeborene, bis 3 Mon.\', \'infant\'=>\'S&auml;glinge, bis 12 Mon.\', \'toddler\'=>\'Kleinkinder, bis 5 Jahre\'), \'MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP\', ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PRESELECT_SIZETYPE'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PRESELECT_SIZETYPE', '', '46163', '545', 'agi_cfg_select_option(array(\'\'=>\'nicht vorbelegt, keine Bekleidung\', \'regular\'=>\'regular\', \'petite\'=>\'Kurz / petite\', \'plus\'=>\'plus size\', \'maternity\'=>\'Umstandsgr&ouml;&szlig;e\'), \'MODULE_AGI_GOOGLE_XML_PRESELECT_SIZETYPE\', ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_MOBILE_LINK'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_MOBILE_LINK', 'false', '46163', '106', 'agi_cfg_select_option(array(\'false\'=>\'nicht angeben\', \'PRODUCT\'=>\'aus Produkteinstellungen\', \'PARAMETER\'=>\'Produktlink + Parametern s. u.\'), \'MODULE_AGI_GOOGLE_XML_MOBILE_LINK\', ', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_MOBILE_LINK_PARAMETER'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_MOBILE_LINK_PARAMETER', 'tpl=mobile&pk_campaign=google_shopping', '46163', '107', '', now())");
      if (!defined('MODULE_AGI_GOOGLE_XML_PASSWORD'))
        xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) VALUES ('MODULE_AGI_GOOGLE_XML_PASSWORD', '', '46163', '600', '', now())");
      
		trigger_error("Updated table configuration set agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    
		// Create Tabel only if not exists
    $q = "CREATE TABLE IF NOT EXISTS `agi_categories_description_add` (
      `categories_id` int(11) NOT NULL,
      `language_id` tinyint(4) NOT NULL DEFAULT '1',
      `google_category` varchar(256) NOT NULL,
      PRIMARY KEY (`categories_id`,`language_id`),
      KEY (`categories_id`),
      KEY `language_id` (`language_id`)
    ) ENGINE=MyISAM;";
    xtc_db_query($q);
    trigger_error("Created table agi_categories_description_add of agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    $q = "CREATE TABLE IF NOT EXISTS `agi_products_description_add` (
      `products_id` int(11) NOT NULL,
      `language_id` tinyint(4) NOT NULL DEFAULT '1',
      `google_category` varchar(256) NOT NULL,
      `google_adwords_redirect` varchar(256) NOT NULL,
      `google_mobile_link` varchar(256) NOT NULL,
      `google_alternative_title` varchar(256) NOT NULL DEFAULT '',
      `google_adwords_grouping` varchar(256) NOT NULL,
      `google_adwords_labels` varchar(256) NOT NULL,
      `google_attribute_color` varchar(128) NOT NULL,
      `google_attribute_size` varchar(128) NOT NULL,
      `google_attribute_pattern` varchar(128) NOT NULL,
      `google_attribute_material` varchar(128) NOT NULL,
      `google_custom_label0` varchar(256) NOT NULL,
      `google_custom_label1` varchar(256) NOT NULL,
      `google_custom_label2` varchar(256) NOT NULL,
      `google_custom_label3` varchar(256) NOT NULL,
      `google_custom_label4` varchar(256) NOT NULL,
      PRIMARY KEY (`products_id`,`language_id`),
      KEY (`products_id`),
      KEY `language_id` (`language_id`)
    ) ENGINE=MyISAM;";
    xtc_db_query($q);
    trigger_error("Created table agi_products_description_add of agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    $q = "CREATE TABLE IF NOT EXISTS `agi_products_add` (
      `products_id` int(11) NOT NULL,
      `google_export` tinyint(1) NOT NULL DEFAULT '1',
      `google_condition` varchar(64) NOT NULL DEFAULT 'new',
      `google_excluded_destination` varchar(64) NOT NULL,
      `google_expiration_date` varchar(64) NOT NULL,
      `google_products_brand` varchar(128) NOT NULL DEFAULT '',
      `google_identifier_exists` tinyint(1) NOT NULL DEFAULT '".(isset($_POST['preselect_identifier_exists']) ? '1' : '0')."',
      `google_multipack_amount` int(5) NOT NULL DEFAULT '1',
      `google_energy_efficiency` varchar(32) NOT NULL DEFAULT '',
      `clothing_product` tinyint(1) NOT NULL DEFAULT '0',
      `google_attribute_gender` varchar(64) NOT NULL,
      `google_attribute_age_group` varchar(64) NOT NULL,
      `google_attribute_size_type` varchar(64) NOT NULL,
      `google_attribute_size_system` varchar(64) NOT NULL,
      PRIMARY KEY (`products_id`)
    ) ENGINE=MyISAM;";
    xtc_db_query($q);
    trigger_error("Created table agi_products_add of agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    $q = "CREATE TABLE IF NOT EXISTS `agi_products_images_to_attributes` (
      `image_nb` int(11) NOT NULL,
      `products_id` int(11) NOT NULL,
      `options_id` int(11) NOT NULL,
      `options_values_id` int(11) NOT NULL,
      PRIMARY KEY (`image_nb`,`products_id`,`options_id`),
      KEY `products_id` (`products_id`)
    ) ENGINE=MyISAM;";
    xtc_db_query($q);
    trigger_error("Created table agi_products_images_to_attributes of agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    $q = "CREATE TABLE IF NOT EXISTS `agi_campaigns` (
      `campaigns_id` int(11) NOT NULL AUTO_INCREMENT,
      `campaigns_name` varchar(32) COLLATE latin1_german1_ci NOT NULL DEFAULT '',
      `campaigns_uripams` varchar(255) COLLATE latin1_german1_ci DEFAULT NULL,
      `date_added` datetime DEFAULT NULL,
      `last_modified` datetime DEFAULT NULL,
      PRIMARY KEY (`campaigns_id`),
      KEY `idx_campaigns_name` (`campaigns_name`)
    ) ENGINE=MyISAM AUTO_INCREMENT=1;";
    xtc_db_query($q);
    trigger_error("Created table agi_campaigns of agi_google_xml-module by " . $_SESSION['customer_id'], E_USER_NOTICE);
    
    // set admin_access
    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_ADMIN_ACCESS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result))
      $db_table_rows[] = $row['Field'];
    
    if (in_array('agi_google_xml_export', $db_table_rows))
    {
      xtc_db_query("ALTER TABLE `" . TABLE_ADMIN_ACCESS . "` CHANGE `agi_google_xml_export` `agi_google_xml_taxonomie` INT(1) NOT NULL DEFAULT 0");
    }
    elseif (!in_array('agi_google_xml_taxonomie', $db_table_rows))
    {
      xtc_db_query("ALTER TABLE `" . TABLE_ADMIN_ACCESS . "` ADD `agi_google_xml_taxonomie` INT(1) NOT NULL DEFAULT 0");
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_google_xml_taxonomie` = 1 WHERE `customers_id` = 1");
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_google_xml_taxonomie` = 1 WHERE `customers_id`='groups'");
      trigger_error("Added column agi_google_xml_taxonomie to table admin_access by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }
    if (in_array('agi_export_campaigns', $db_table_rows))
    {
      xtc_db_query("ALTER TABLE `" . TABLE_ADMIN_ACCESS . "` CHANGE `agi_export_campaigns` `agi_google_xml_campaigns` INT(1) NOT NULL DEFAULT 0");
    }
    elseif (!in_array('agi_google_xml_campaigns', $db_table_rows))
    {
      xtc_db_query("ALTER TABLE `" . TABLE_ADMIN_ACCESS . "` ADD `agi_google_xml_campaigns` INT(1) NOT NULL DEFAULT 0");
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_google_xml_campaigns` = 1 WHERE `customers_id` = 1");
      xtc_db_query("UPDATE `" . TABLE_ADMIN_ACCESS . "` SET `agi_google_xml_campaigns` = 1 WHERE `customers_id`='groups'");
      trigger_error("Added column agi_google_xml_campaigns to table admin_access by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }
    
    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_SHIPPING_STATUS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result))
      $db_table_rows[] = $row['Field']; 
    if (!in_array('google_status_name', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `" . TABLE_SHIPPING_STATUS . "` ADD `google_status_name` VARCHAR( 64 ) NOT NULL DEFAULT 'in stock'");
      trigger_error("Added column to table ".TABLE_SHIPPING_STATUS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }

    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_PRODUCTS_OPTIONS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result))
      $db_table_rows[] = $row['Field'];
    if (!in_array('is_google_attribute', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `" . TABLE_PRODUCTS_OPTIONS . "` ADD `is_google_attribute` VARCHAR( 64 ) NOT NULL");
      trigger_error("Added column to table ".TABLE_PRODUCTS_OPTIONS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }
		
    $this->_file_activation(1);
	}

	function remove() {
    $keys = $this->keys();
    foreach ($keys as $key) {
      if ($key == 'MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL')
        continue;
      xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = '".$key."'");
      trigger_error("Deleted congiguration_key $key by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }
		// Delete only if MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL is set true, standard is false
		if (defined('MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL') && strtolower(MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL) == 'true'){
			xtc_db_query("DROP TABLE agi_products_description_add");
			trigger_error("Dropped table agi_products_description_add by " . $_SESSION['customer_id'], E_USER_NOTICE);
      xtc_db_query("DROP TABLE agi_categories_description_add");
			trigger_error("Dropped table agi_categories_description_add by " . $_SESSION['customer_id'], E_USER_NOTICE);
      xtc_db_query("DROP TABLE agi_products_add");
			trigger_error("Dropped table agi_products_add by " . $_SESSION['customer_id'], E_USER_NOTICE);
      xtc_db_query("DROP TABLE agi_products_images_to_attributes");
			trigger_error("Dropped table agi_products_images_to_attributes by " . $_SESSION['customer_id'], E_USER_NOTICE);
      xtc_db_query("DROP TABLE agi_export_campaigns");
			trigger_error("Dropped table agi_export_campaigns by " . $_SESSION['customer_id'], E_USER_NOTICE);
      
      xtc_db_query("ALTER TABLE `".TABLE_SHIPPING_STATUS."` DROP `google_status_name`;");
      trigger_error("Deleted column agi_google_xml from table ".TABLE_SHIPPING_STATUS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
      xtc_db_query("ALTER TABLE `".TABLE_PRODUCTS_OPTIONS."` DROP `is_google_attribute`;");
      trigger_error("Deleted column agi_google_xml from table ".TABLE_PRODUCTS_OPTIONS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
			
		}
		xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL'");
    
    $query_result = xtc_db_query("SHOW COLUMNS FROM `" . TABLE_ADMIN_ACCESS . "`");
    $db_table_rows = array();
    while ($row = xtc_db_fetch_array($query_result))
      $db_table_rows[] = $row['Field'];
    if (in_array('agi_google_xml_taxonomie', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `".TABLE_ADMIN_ACCESS."` DROP `agi_google_xml_taxonomie`;");
      trigger_error("Deleted column agi_google_xml_taxonomie from table ".TABLE_ADMIN_ACCESS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
    }
    if (in_array('agi_google_xml_campaigns', $db_table_rows)) {
      xtc_db_query("ALTER TABLE `".TABLE_ADMIN_ACCESS."` DROP `agi_google_xml_campaigns`;");
      trigger_error("Deleted column agi_google_xml_campaigns from table ".TABLE_ADMIN_ACCESS." by " . $_SESSION['customer_id'], E_USER_NOTICE);
		}
		$this->_file_activation(0);

	}
  
  function _file_activation($status=1) {
    $from_ext = $status ? 'php_deact' : 'php';
    $to_ext   = $status ? 'php' : 'php_deact';
    $files = array(
      DIR_FS_CATALOG.DIR_ADMIN.'includes/extra/menu/agi_google_xml',
      DIR_FS_CATALOG.DIR_ADMIN.'includes/extra/modules/new_product/agi_google_xml',
      // DIR_FS_CATALOG.'includes/extra/database_tables/agi_google_xml', ist unabhngig
    );
    // Only load files from autoinclude-directories if install of database-tables was successful
		// autoinclude-files are not loaded if fileextensiuon is not php
		// just rename files
    try{
      foreach ($files as $file) {
        if(file_exists($file.'.'.$from_ext))
          rename($file.'.'.$from_ext, $file.'.'.$to_ext);
      }
		}
		catch(Exception $e){
			trigger_error("Install of module dummy failed: ".$e->getMessage(), E_USER_ERROR);
		}
  }
	function keys() {
		$key = array(
      'MODULE_AGI_GOOGLE_XML_STATUS', 
      'MODULE_AGI_GOOGLE_XML_DELETE_DATA_ON_UNINSTALL',
      'MODULE_AGI_GOOGLE_XML_FEED_NB_ARTICLE',
      'MODULE_AGI_GOOGLE_XML_VPE_TITLE',
      'MODULE_AGI_GOOGLE_XML_VPE_DESCRIPTION',
      'MODULE_AGI_GOOGLE_XML_CHECK_GRADUATED_PRICE',
      'MODULE_AGI_GOOGLE_XML_LONG_DESCRIPTION',
      'MODULE_AGI_GOOGLE_XML_AVAILABILITY_FROM',
      'MODULE_AGI_GOOGLE_XML_SHIPPING_LIST',
      'MODULE_AGI_GOOGLE_XML_SHIPPING_BASE',
      'MODULE_AGI_GOOGLE_XML_IGNORE_FREESHIPPING_MODULES',
      'MODULE_AGI_GOOGLE_XML_USE_PRODUCT_IMAGE',
      'MODULE_AGI_GOOGLE_XML_DEFAULT_CATEGORY',
      'MODULE_AGI_GOOGLE_XML_DEFAULT_CL_SIZESYSTEM',
      'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_MALE',
      'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_FEMALE',
      'MODULE_AGI_GOOGLE_XML_GENDER_WORDS_UNISEX',
      'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_KIDS',
      'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_ADULT',
      'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_NEWBORN',
      'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_INFANT',
      'MODULE_AGI_GOOGLE_XML_AGE_GROUP_WORDS_TODDLER',
      'MODULE_AGI_GOOGLE_XML_VPE_VALUES',
      'MODULE_AGI_GOOGLE_XML_IGNORE_VPE_VALUES',
      'MODULE_AGI_GOOGLE_XML_CAMPAIGN',
      'MODULE_AGI_GOOGLE_XML_EXPORT_SSL_LINKS',
      'MODULE_AGI_GOOGLE_XML_SHOP_IS_UTF8',
      'MODULE_AGI_GOOGLE_XML_USE_FUX_SEO',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_EXPORT_ALLOWED',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_CLOTHING_PRODUCT',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_IDENTIFIER_EXISTS',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_CONDITION',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_GENDER',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_AGEGROUP',
      'MODULE_AGI_GOOGLE_XML_PRESELECT_SIZETYPE',
      'MODULE_AGI_GOOGLE_XML_MOBILE_LINK',
      'MODULE_AGI_GOOGLE_XML_MOBILE_LINK_PARAMETER',
      'MODULE_AGI_GOOGLE_XML_PASSWORD',
      'MODULE_AGI_GOOGLE_XML_ATTRIBUTE_LIMIT',
      'MODULE_AGI_GOOGLE_XML_AUTOINCLUDE_APPLICATION_TOP_BEGINN'
    );

		return $key;
	}
}
function agi_cfg_select_option($select_array, $key_name, $key_value) {
  reset($select_array);
  $string = '';
  while (list ($key, $value) = each($select_array)) {
    if (is_int($key))
      $key = $value;
    $string .= '<br /><input type="radio" name="configuration['.$key_name.']" value="'.$key.'"';
    if ($key_value == $key)
      $string .= ' checked="checked"';
    $string .= '> '.$value;
  }
  return $string;
}
?>